<?php
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)

Developed by Andrey Chikaev (https://vk.com/winchikplay)

*/
class createController extends Controller {
	public function index($ticketid = null) {
		$this->document->setActiveSection('tickets');
		$this->document->setActiveItem('create');
		$this->data['url'] = $this->config->url;

		if($this->user->isLogged()) {
            $this->data['logged'] = true;
            $this->data['user_email'] = $this->user->getEmail();
            $this->data['user_firstname'] = $this->user->getFirstname();
            $this->data['user_lastname'] = $this->user->getLastname();
            $this->data['user_balance'] = $this->user->getBalance();
            $this->data['user_access_level'] = $this->user->getAccessLevel();
            $this->data['user_img'] = $this->user->getUser_img();
        } else {
            $this->data['logged'] = false;
            $this->data['user_access_level'] = 0;
        }
		
		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		if($this->user->getAccessLevel() < 2) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		$this->load->model('users');
		$userid = $this->user->getId();
		$this->getChild(array('common/admheader', 'common/footer'));
		return $this->load->view('admin/tickets/create', $this->data);
	}
	
	public function ajax($ticketid = null) {
		if(!$this->user->isLogged()) {  
	  		$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 1) {
	  		$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		
		$this->load->model('tickets');
		$this->load->model('ticketsMessages');
		$this->load->model('ticketsImages');
		
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$errorPOST = $this->validatePOST();
			if(!$errorPOST) {
				$name = @$this->request->post['name'];
				$text = @$this->request->post['text'];
				$pid = @$this->request->post['pid'];
				$userid = $this->user->getId();
				
				$ticketData = array(
					'user_id'			=> $pid,
					'ticket_name'		=> $name,
					'ticket_status'		=> 2
				);
				$ticketid = $this->ticketsModel->createTicket($ticketData);
				
				$messageData = array(
					'ticket_id'			=> $ticketid,
					'user_id'			=> $userid,
					'ticket_message'	=> $text
				);
				$this->ticketsMessagesModel->createTicketMessage($messageData);
				
				$this->data['status'] = "success";
				$this->data['success'] = "Вы успешно отправили сообщение пользователю!";
				$this->data['id'] = $ticketid;
				foreach ($_FILES['file']['name'] as $k=>$v)
				{
					$uploaddir = "tmp/tickets_img/";
					$apend=date('YmdHis').rand(100,1000).'.png';
					$uploadfile = "$uploaddir$apend";
					if($_FILES['file']['type'][$k] == "image/gif" || $_FILES['file']['type'][$k] == "image/png" || $_FILES['file']['type'][$k] == "image/jpg" || $_FILES['file']['type'][$k] == "image/jpeg")
				{
				$blacklist = array(".php", ".phtml", ".php3", ".php4");
				foreach ($blacklist as $item)
				{
					if(preg_match("/$item\$/i", $_FILES['file']['name'][$k]))
				{
				$this->data['status'] = "error";
				$this->data['error'] = "Нельзя загружать скрипты.";
				}
				}
				if (move_uploaded_file($_FILES['file']['tmp_name'][$k], $uploadfile))
				{
					$size = getimagesize($uploadfile);
					if ($size[0] < 1500 && $size[1] < 1500)
				{

				$ticket1Data = array(
					'ticket_id'		=> $ticketid,
					'image'		=> $uploadfile
				);	    
				$this->ticketsImagesModel->createImage($ticket1Data);
				$kk = $k+1;
				} else {
					$this->data['status'] = "error";
					$this->data['error'] = "Изображение превышает пиксили.";
					unlink($uploadfile);
				}
				} else {
				$this->data['status'] = "error";
				$this->data['error'] = "Файл не загружен.";
				}          
				} else {     
				$this->data['status'] = "error";
				$this->data['error'] = "Можно загружать только изображения в форматах jpg, jpeg, gif и png";}
				}
			} else {
				$this->data['status'] = "error";
				$this->data['error'] = $errorPOST;
			}
		}

		return json_encode($this->data);
	}
	
	private function validatePOST() {
		$result = null;
		
		$name = @$this->request->post['name'];
		$pid = @$this->request->post['pid'];
		$text = @$this->request->post['text'];
		
		if(mb_strlen($name) < 6 || mb_strlen($name) > 32) {
			$result = "Название тикета должно содержать от 6 до 32 символов!";
		}
		elseif(mb_strlen($pid) < 1 || mb_strlen($pid) > 5) {
			$result = "ID клиента должен быть от 1 до 5 символов!";
		}
		elseif(mb_strlen($text) < 10 || mb_strlen($text) > 350) {
			$result = "Текст тикета должен содержать от 10 до 350 символов!";
		}
		return $result;
	}
}
