<?php
/*
Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Andrey Chikaev (https://vk.com/winchikplay)
*/
class viewController extends Controller {
	public function index($ticketid = null) {
		$this->document->setActiveSection('admin');
		$this->document->setActiveItem('tickets');
        $this->data['url'] = $this->config->url;

        if($this->user->isLogged()) {
            $this->data['logged'] = true;
            $this->data['user_email'] = $this->user->getEmail();
            $this->data['user_firstname'] = $this->user->getFirstname();
            $this->data['user_lastname'] = $this->user->getLastname();
            $this->data['user_balance'] = $this->user->getBalance();
            $this->data['user_access_level'] = $this->user->getAccessLevel();
            $this->data['user_img'] = $this->user->getUser_img();
        } else {
            $this->data['logged'] = false;
            $this->data['user_access_level'] = 0;
        }
		
		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		if($this->user->getAccessLevel() < 2) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		
		$this->load->model('tickets');
		$this->load->model('ticketsMessages');
		$this->load->model('ticketsImages');
		$this->load->model('users');
		
		$error = $this->validate($ticketid);
		if($error) {
			$this->session->data['error'] = $error;
			$this->response->redirect($this->config->url . 'admin/tickets/index');
		}
		
		$ticket = $this->ticketsModel->getTicketById($ticketid, array('users'));
		$messages = $this->ticketsMessagesModel->getTicketsMessages(array('ticket_id' => $ticketid), array('users'));
		$images = $this->ticketsImagesModel->getImages(array('ticket_id' => $ticketid), array());
		$this->data['ticket'] = $ticket;
		$this->data['messages'] = $messages;
		$this->data['user_img'] = $this->user->getUser_img();
		$this->data['images'] = $images;
		
		$this->getChild(array('common/admheader', 'common/footer'));
		return $this->load->view('admin/tickets/view', $this->data);
	}
	
	public function ajax($ticketid = null) {
		if(!$this->user->isLogged()) {  
	  		$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 2) {
			$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		
		$this->load->library('mail');
		
		$this->load->model('tickets');
		$this->load->model('ticketsMessages');
		$this->load->model('ticketsImages');
		
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$errorPOST = $this->validatePOST($ticketid);
			if(!$errorPOST) {
				$text = @$this->request->post['text'];
				$closeticket = @$this->request->post['closeticket'];
				
				$userid = $this->user->getId();
				
				if($closeticket) {
					$this->ticketsModel->updateTicket($ticketid, array('ticket_status' => 0));
					
					$this->data['status'] = "success";
					$this->data['success'] = "Вы успешно закрыли запрос!";
				} else {
					$messageData = array(
						'ticket_id'			=> $ticketid,
						'user_id'			=> $userid,
						'ticket_message'	=> $text
					);
					$this->ticketsModel->updateTicket($ticketid, array('ticket_status' => 2));
					$this->ticketsMessagesModel->createTicketMessage($messageData);
					
					$ticket = $this->ticketsModel->getTicketById($ticketid, array('users'));
					
					$mailLib = new mailLibrary();
					
					$mailLib->setFrom($this->config->mail_from);
					$mailLib->setSender($this->config->mail_sender);
					$mailLib->setTo($ticket['user_email']);
					$mailLib->setSubject("Новый ответ в тикете #$ticketid");
					
					$mailData = array();
					
					$mailData['firstname'] = $ticket['user_firstname'];
					$mailData['lastname'] = $ticket['user_lastname'];
					$mailData['ticketid'] = $ticketid;
					
					$text = $this->load->view('mail/tickets/newMessage', $mailData);
					
					$mailLib->setText($text);
					$mailLib->send();
					
					$this->data['status'] = "success";
					$this->data['success'] = "Вы успешно отправили сообщение!";
				}
				foreach ($_FILES['file']['name'] as $k=>$v)
				{
					$uploaddir = "tmp/tickets_img/";
					$apend=date('YmdHis').rand(100,1000).'.png';
					$uploadfile = "$uploaddir$apend";
					if($_FILES['file']['type'][$k] == "image/gif" || $_FILES['file']['type'][$k] == "image/png" || $_FILES['file']['type'][$k] == "image/jpg" || $_FILES['file']['type'][$k] == "image/jpeg")
				{
				$blacklist = array(".php", ".phtml", ".php3", ".php4");
				foreach ($blacklist as $item)
				{
					if(preg_match("/$item\$/i", $_FILES['file']['name'][$k]))
				{
				$this->data['status'] = "error";
				$this->data['error'] = "Нельзя загружать скрипты.";
				}
				}
				if (move_uploaded_file($_FILES['file']['tmp_name'][$k], $uploadfile))
				{
					$size = getimagesize($uploadfile);
					if ($size[0] < 1500 && $size[1] < 1500)
				{

				$ticket1Data = array(
					'ticket_id'		=> $ticketid,
					'image'		=> $uploadfile
				);	    
				$this->ticketsImagesModel->createImage($ticket1Data);
				$kk = $k+1;
				} else {
					$this->data['status'] = "error";
					$this->data['error'] = "Изображение превышает пиксили.";
					unlink($uploadfile);
				}
				} else {
				$this->data['status'] = "error";
				$this->data['error'] = "Файл не загружен.";
				}          
				} else {     
				$this->data['status'] = "error";
				$this->data['error'] = "Можно загружать только изображения в форматах jpg, jpeg, gif и png";}
				}
			} else {
				$this->data['status'] = "error";
				$this->data['error'] = $errorPOST;
			}
		}

		return json_encode($this->data);
	}
	public function action($ticketid = null, $action = null) {
		if(!$this->user->isLogged()) {
			$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 0) {
	  		$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		$this->load->model('tickets');
		$this->load->model('ticketsMessages');
		switch($action) {
			case 'closed': {
				$this->ticketsModel->updateTicket($ticketid, array('ticket_status' => 0));
					
					$this->data['status'] = "success";
					$this->data['success'] = "Вы успешно закрыли запрос!";
				break;
			}
			default: {
				$this->data['status'] = "error";
				$this->data['error'] = "Вы выбрали несуществующее действие!";
				break;
			}
		}
		return json_encode($this->data);
	}
	private function validate($ticketid) {
		$result = null;
		
		if(!$this->ticketsModel->getTotalTickets(array('ticket_id' => (int)$ticketid))) {
			$result = "Запрашиваемый тикет не существует!";
		}
		return $result;
	}
	
	private function validatePOST($ticketid) {
		$result = null;
		
		$text = @$this->request->post['text'];
		$closeticket = @$this->request->post['closeticket'];
		
		if(!$closeticket) {
			if(mb_strlen($text) < 10 || mb_strlen($text) > 350) {
				$result = "Текст сообщения должен содержать от 10 до 350 символов.";
			}
		}
		return $result;
	}
}
