<?
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Alexandr Zemlyanoy (https://vk.com/mrsasha082)
WEB Hosting to ISP 5
*/
class controlController extends Controller {
	public function index($webid = null) {
		$this->document->setActiveSection('webhost');
		$this->document->setActiveItem('index');
		
		$this->data['title'] = $this->config->title;
		$this->data['description'] = $this->config->description;
		$this->data['keywords'] = $this->config->keywords;
		$this->data['logo'] = $this->config->logo;
		$this->data['url'] = $this->config->url;
		$this->data['public'] = $this->config->public;
		$this->data['oplata_status'] = $this->config->oplata_status;
		$this->data['oplatahackchik'] = $this->config->oplatahackchik;
		$this->data['status_hackchik'] = $this->config->status_hackchik;	
		$this->data['activesection'] = $this->document->getActiveSection();
		$this->data['activeitem'] = $this->document->getActiveItem();

		if($this->user->isLogged()) {
			$this->data['logged'] = true;
			$this->data['user_email'] = $this->user->getEmail();
			$this->data['user_firstname'] = $this->user->getFirstname();
			$this->data['user_lastname'] = $this->user->getLastname();
			$this->data['user_balance'] = $this->user->getBalance();
			$this->data['user_access_level'] = $this->user->getAccessLevel();
			$this->data['user_img'] = $this->user->getUser_img();
		} else {
			$this->data['logged'] = false;
			$this->data['user_access_level'] = 0;
		}
		
		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		if($this->user->getAccessLevel() < 2) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		
		$userid = $this->user->getId();	
		$this->data['user_balance'] = $this->user->getBalance();
		$this->load->model('webhost');		
        $this->load->model('webhostTarifs');
		$this->load->model('webLocations');
		
		$error = $this->validate($webid);
		if($error) {
			$this->session->data['error'] = $error;
			$this->response->redirect($this->config->url . 'admin/webhost/index');
		}
		
		$webhost = $this->webhostModel->getWebhostById($webid, array('users','web_tarifs','web_locations'));
		$tarifs = $this->webhostTarifsModel->getTarifs(array('tarif_status' => 1));
		$locations = $this->webLocationsModel->getLocations(array('location_status' => 1));
		$this->data['webhost'] = $webhost;
		$this->data['tarifs'] = $tarifs;
		$this->data['locations'] = $locations;
		
		$this->getChild(array('common/admheader', 'common/footer'));
		return $this->load->view('admin/webhost/control', $this->data);
	}
	
	
	public function ajax($webid = null) {
		if(!$this->user->isLogged()) {  
	  		$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 2) {
	  		$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}	
		$this->load->model('webhost');
	
		$error = $this->validate($webid);
		if($error) {
			$this->data['status'] = "error";
			$this->data['error'] = $error;
			return json_encode($this->data);
		}
		
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$errorPOST = $this->validatePOST();
			if(!$errorPOST) {
				$editpassword = @$this->request->post['editpassword'];
				$password = @$this->request->post['password'];
				if($editpassword) {
					$this->webhostModel->updatepassUser($webid, $password);
					$this->webhostModel->updatepassFtp($webid, $password);	
					$this->webhostModel->updateWebhost($webid, array('web_password' => $password));	
					$this->data['status'] = "success";
					$this->data['success'] = "Пароль успешно изменен!";
				} else {
					$this->data['status'] = "error";
					$this->data['error'] = "Ошибка!";
				}
			} else {
				$this->data['status'] = "error";
				$this->data['error'] = $errorPOST;
			}
		}

		return json_encode($this->data);
	}
	
	public function action($webid = null, $action = null) {
		if(!$this->user->isLogged()) {
			$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 2) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		$this->load->model('webhost');
		$this->load->model('webhostTarifs');
		$this->load->library('ssh2');
		$ssh2Lib = new ssh2Library();
		
		$error = $this->validate($webid);
		if($error) {
			$this->data['status'] = "error";
			$this->data['error'] = $error;
			return json_encode($this->data);
		}
		
		$webhost = $this->webhostModel->getWebhostById($webid, array('users', 'web_tarifs'));
			
		switch($action) {
			case 'block': {
				$this->webhostModel->blockWebhost($webid);
				$this->data['status'] = "success";
				$this->data['success'] = "Вы успешно заблокировали веб-хостинг!";
				break;
			}
			case 'unblock': {
				$this->webhostModel->unblockWebhost($webid);
				$this->data['status'] = "success";
				$this->data['success'] = "Вы успешно разблокировали веб-хостинг!";
				break;
			}
			case 'detele_web': {
				$this->webhostModel->unblockWebhost($webid);
				$this->webhostModel->deleteWebhost($webid);
				$this->data['status'] = "success";
				$this->data['success'] = "Вы успешно удалили веб-хостинг!";
				break;
			}
			default: {
				$this->data['status'] = "error";
				$this->data['error'] = "Вы выбрали несуществующее действие!";
				break;
			}
		}
		
		return json_encode($this->data);
	}

	private function validate($webid) {
		$result = null;
		
		if(!$this->webhostModel->getTotalWebhosts(array('web_id' => (int)$webid))) {
			$result = "Запрашиваемый веб-хостинг не существует!";
		}
		return $result;
	}
	
	private function validatePOST() {
		$this->load->library('validate');
		
		$validateLib = new validateLibrary();
		
		$result = null;
		
		$editpassword = @$this->request->post['editpassword'];
		$password = @$this->request->post['password'];
		$password2 = @$this->request->post['password2'];

		if($editpassword) {
			if(!$validateLib->password_web($password)) {
				$result = "Пароль должен содержать от 8 до 32 латинских букв, цифр и знаков <i>,.!?_-</i>!";
			}
			elseif(!$validateLib->password_web1($password)) {
				$result = "Вы придумали слабый пароль!";
			}
			elseif(!$validateLib->password_web2($password)) {
				$result = "Вы придумали простой пароль!";
			}
			elseif($password != $password2) {
				$result = "Введенные вами пароли не совпадают!";
			}
		}
		return $result;
	}
}
?>
