<?
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Alexandr Zemlyanoy (https://vk.com/mrsasha082)
WEB Hosting to ISP 5
*/
class indexController extends Controller {
	private $limit = 20;
	public function index($page = 1) {
		$this->document->setActiveSection('webhost');
		$this->document->setActiveItem('index');
	
		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не залогинены!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		if($this->user->getAccessLevel() < 2) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		
		$this->load->library('pagination');
		$this->load->model('webhost');
		
		$userid = $this->user->getId();
		
		$getData = array();
		
		if(isset($this->request->get['userid'])) {
			$getData['webhost.user_id'] = (int)$this->request->get['userid'];
		}
		
		if(isset($this->request->get['tariffid'])) {
			$getData['webhost.tariff_id'] = (int)$this->request->get['tariffid'];
		}
		
		if(isset($this->request->get['locationid'])) {
			$getData['webhost.location_id'] = (int)$this->request->get['locationid'];
		}
		
		$getOptions = array(
			'start' => ($page - 1) * $this->limit,
			'limit' => $this->limit
		);
		
		$total = $this->webhostModel->getTotalWebhosts($getData);
		$webhosts = $this->webhostModel->getWebhosts($getData, array('web_tarifs', 'web_locations'), array(), $getOptions);
		
		$paginationLib = new paginationLibrary();
		$paginationLib->total = $total;
		$paginationLib->page = $page;
		$paginationLib->limit = $this->limit;
		$paginationLib->url = $this->config->url . 'admin/webhost/index/index/{page}';
		
		$pagination = $paginationLib->render();
		
		$this->data['webhosts'] = $webhosts;
		$this->data['pagination'] = $pagination;
		
		$this->getChild(array('common/admheader', 'common/footer'));
		return $this->load->view('admin/webhost/index', $this->data);
	}
}
?>
