<?
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Alexander Zemlyanoy (https://vk.com/mrsasha082)
WEB Hosting to ISP 5
*/
class createController extends Controller {
	public function index() {
		$this->document->setActiveSection('admin');
		$this->document->setActiveItem('webtarifs');
		
		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		if($this->user->getAccessLevel() < 3) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		
		$this->getChild(array('common/admheader', 'common/footer'));
		return $this->load->view('admin/webtarifs/create', $this->data);
	}
	
	public function ajax() {
		if(!$this->user->isLogged()) {  
	  		$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 3) {
			$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		
		$this->load->model('webhostTarifs');
		
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$errorPOST = $this->validatePOST();
			if(!$errorPOST) {
				$name = @$this->request->post['name'];
				$package = @$this->request->post['package'];
				$price = @$this->request->post['price'];
				$status = @$this->request->post['status'];
				
				$tarifData = array(
					'tarif_name'		=> $name,
					'package'			=> $package,
					'tarif_price'		=> (float)$price,
					'tarif_status'		=> (int)$status
				);
				
				$this->webhostTarifsModel->createTarif($tarifData);
				
				$this->data['status'] = "success";
				$this->data['success'] = "Вы успешно создали тариф!";
			} else {
				$this->data['status'] = "error";
				$this->data['error'] = $errorPOST;
			}
		}

		return json_encode($this->data);
	}
	
	private function validatePOST() {
		$this->load->library('validate');
		
		$validateLib = new validateLibrary();
		
		$result = null;
		
		$name = @$this->request->post['name'];
		$package = @$this->request->post['package'];
		$price = @$this->request->post['price'];
		$status = @$this->request->post['status'];
		
		if(mb_strlen($name) < 2 || mb_strlen($name) > 32) {
			$result = "Название тарифа должно содержать от 2 до 32 символов!";
		}
		elseif(mb_strlen($package) < 1 || mb_strlen($package) > 32) {
			$result = "Название пакета должно содержать от 2 до 32 символов!";
		}
		elseif(!$validateLib->money($price)) {
			$result = "Укажите допустимую стоимость!";
		}
		elseif($status < 0 || $status > 1) {
			$result = "Укажите допустимый статус!";
		}
		return $result;
	}
}
?>
