<?
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Alexander Zemlyanoy (https://vk.com/mrsasha082)
WEB Hosting to ISP 5
*/
class indexController extends Controller {

	private $limit = 20;
	public function index($page = 1) {
		$this->document->setActiveSection('admin');
		$this->document->setActiveItem('webtarifs');
		
		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		if($this->user->getAccessLevel() < 3) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		
		$this->load->library('pagination');
		$this->load->model('webhostTarifs');
		
		$options = array(
			'start' => ($page - 1) * $this->limit,
			'limit' => $this->limit
		);
		
		$total = $this->webhostTarifsModel->getTotalTarifs();
		$tarifs = $this->webhostTarifsModel->getTarifs(array(), array(), $options);
		
		$paginationLib = new paginationLibrary();
		
		$paginationLib->total = $total;
		$paginationLib->page = $page;
		$paginationLib->limit = $this->limit;
		$paginationLib->url = $this->config->url . 'admin/webtarifs/index/index/{page}';
		
		$pagination = $paginationLib->render();
		
		$this->data['tarifs'] = $tarifs;
		$this->data['pagination'] = $pagination;
		
		$this->getChild(array('common/admheader', 'common/footer'));
		return $this->load->view('admin/webtarifs/index', $this->data);
	}
}
?>
