<?php
	
	class pagesController extends Controller {
		
		public function index() {
			
			$page = @$this->request->post['page'];
			
			$this->load->model('users');

			if($this->request->server['REQUEST_METHOD'] == 'POST' && !empty($page)) {
				$this->action->make($page, false, true);
				$content = $this->action->go();
				if($this->document->getLoggedRequired() && !$this->user->isLogged()) {
					$this->data['status'] = 'error';
					$this->data['error'] = 'bad_token';
					return json_encode($this->data);
				}
				if($this->document->getLoggedRequired() && $this->document->getAccessLevel() > $this->user->getAccessLevel()) {
					$this->data['status'] = 'error';
					$this->data['error'] = 'bad_access';
					return json_encode($this->data);
				}
				$title = $this->document->getTitle() != null ? $this->document->getTitle() : $this->config->title;
				$section = $this->document->getActiveSection();
				
				$user = array();
				if($this->user->isLogged()) {
					$userid = $this->user->getId();
					$userData = $this->usersModel->getUserById($userid);
					
					if($userData['user_last_ip'] != $this->user->getRealIpAdress() && $userData['user_ip_confirmation'] == 1 && $page != '/account/ipconfirmation') {
						$this->data['status'] = 'error';
						$this->data['error'] = 'ip_confirmation';
						return json_encode($this->data);
					}
					
					$user['name'] = $this->user->getName();
					$user['balance'] = $this->user->getBalance();
					$user['avatar'] = $this->user->getUserAvatar();
				}
				
				$guest = $this->document->getGuest() == true ? 'true' : 'false';
				
				return json_encode(array('status' => 'ok', 'title' => $title, 'section' => $section, 'logged' => $this->user->isLogged(), 'user' => $user, 'guest' => $guest, 'content' => $content));
			}
			$this->data['status'] = 'error';
			$this->data['error'] = 'bad_request';
			return json_encode($this->data);
		}
		
	}
?>
