<?php
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)

Developed by Andrey Chikaev (https://vk.com/winchikplay)

Developed by Alexandr Zemlyanoy (https://vk.com/mrsasha082) -> WEB Hosting to ISP 5
*/
class cronController extends Controller {
	public function index() {
		$this->load->library('mail');
		$this->load->library('ssh2');
		$this->load->model('webhost');
		$this->load->model('servers');
		$this->load->model('serversStats');
		$this->load->model('serversOwners');
		$this->load->model('serversFirewalls');
		$this->load->model('serverLog');
		$this->load->model('invoices');
		$token = @$this->request->get['token'];
		if($this->config->token != $token) {
			return "Access Denied";
		}
		
		$mailLib = new mailLibrary();
		
		$mailLib->setFrom($this->config->mail_from);
		$mailLib->setSender($this->config->mail_sender);
		
		$servers = $this->serversModel->getServers(array(), array('users'));
		$webhosts = $this->webhostModel->getWebhosts(array(), array('users'));
		
		$datenow = date_create('now');

		foreach($servers as $item) {
			$operation = false;
			$serverid = $item['server_id'];
			$dateend = date_create($item['server_date_end']);
			$diff = date_diff($datenow, $dateend);
							
			if($diff->invert) {
				if($diff->days >= 1) {
					if($this->serversModel->action($serverid, 'delete')["status"] != "success") {
						$operation = true;
						echo "Игровой сервер: gs" . $serverid . " - удаление не удалось.\n";
					}
					
					if(!$operation) {
						if($item['server_mysql'] ==  1 || $item['server_mysql'] ==  2) {
							$this->serversModel->action($serverid, "delete_mysql");
						}
						$this->serversModel->deleteServer($serverid);
						$this->serversStatsModel->deleteServerStats($serverid);
						$this->serversOwnersModel->deleteserverOwners($serverid);
						$this->serverLogModel->deleteLog($serverid);
						
						$firewall = $this->serversFirewallsModel->getFirewallsById($serverid);

						if ($firewall) {
							foreach ($firewall as $item2) {
								$ssh2Lib = new ssh2Library();
								$link = $ssh2Lib->connect($item['location_ip'], $item['location_user'], $item['location_password']);
								
								$ssh2Lib->execute($link, "iptables -D INPUT -s ".$item2['server_ip']." -p udp -d ".$item['location_ip']." --dport ".$item['server_port']." -j DROP;");
								$ssh2Lib->execute($link, "iptables -D INPUT -s ".$item2['server_ip']." -p tcp -d ".$item['location_ip']." --dport ".$item['server_port']." -j DROP;");
								
								$ssh2Lib->disconnect($link);
								
								$this->serversFirewallsModel->deleteFirewallDB($item2['firewall_id']);
							}
						}
									
						$mailLib->setTo($item['user_email']);
						$mailLib->setSubject("Удаление сервера #$serverid");
									
						$mailData = array();
						$mailData['firstname'] = $item['user_firstname'];
						$mailData['lastname'] = $item['user_lastname'];
						$mailData['serverid'] = $serverid;
										
						$text = $this->load->view('mail/servers/deleted', $mailData);
									
						$mailLib->setText($text);
						$mailLib->send();
					
						echo "Игровой сервер: gs" . $serverid . " - удален.\n";
					}
				} else if($item['server_status'] != 0) {
					if($this->serversModel->action($serverid, "stop")["status"] == "success") {
						$this->serversModel->updateServer($serverid, array('server_status' => 0));
						$this->serversModel->action($serverid, "block");
					} else {
						$operation = true;
						echo "Игровой сервер: gs" . $serverid . " - блокировка не удалась.\n";
					}
								
					if(!$operation) {	
						$mailLib->setTo($item['user_email']);
						$mailLib->setSubject("Блокировка сервера #$serverid");
								
						$mailData = array();
						$mailData['firstname'] = $item['user_firstname'];
						$mailData['lastname'] = $item['user_lastname'];
						$mailData['serverid'] = $serverid;
								
						$text = $this->load->view('mail/servers/lock', $mailData);
								
						$mailLib->setText($text);
						$mailLib->send();
						
						echo "Игровой сервер: gs" . $serverid . " - заблокирован.\n";
					}
				}
			} else {
				if($diff->days < 3) {		
					$mailLib->setTo($item['user_email']);
					$mailLib->setSubject("Завершение оплаченного периода сервера #$serverid");
										
					$mailData = array();
					$mailData['firstname'] = $item['user_firstname'];
					$mailData['lastname'] = $item['user_lastname'];
					$mailData['serverid'] = $serverid;
					$mailData['days'] = $diff->days;
							
					$text = $this->load->view('mail/servers/needPay', $mailData);
								
					$mailLib->setText($text);
					$mailLib->send();
					
					echo "Игровой сервер: gs" . $serverid . " - отправлено уведомление.\n";
				}
			}
		}

		foreach($webhosts as $item) {
			$operation = false;
			$webid = $item['web_id'];
			$dateend = date_create($item['web_date_end']);
			$diff = date_diff($datenow, $dateend);
							
			if($diff->invert) {
				if($diff->days >= 3) {
					$this->webhostModel->unblockWebhost($webid);
					$this->webhostModel->deleteWebhost($webid);

					$mailLib->setTo($item['user_email']);
					$mailLib->setSubject("Удаление веб-хостинга #$webid");
					
					$mailData = array();
					$mailData['firstname'] = $item['user_firstname'];
					$mailData['lastname'] = $item['user_lastname'];
					$mailData['webid'] = $webid;
					
					$text = $this->load->view('mail/webhost/deleted', $mailData);
					
					$mailLib->setText($text);
					$mailLib->send();
					
					echo "Веб-хостинг: ws" . $webid . " - удален.\n";
				} else if($item['web_status'] != 0) {
					$this->webhostModel->blockWebhost($webid);

					$mailLib->setTo($item['user_email']);
					$mailLib->setSubject("Блокировка веб-хостинга #$webid");
			
					$mailData = array();
					$mailData['firstname'] = $item['user_firstname'];
					$mailData['lastname'] = $item['user_lastname'];
					$mailData['webid'] = $webid;
			
					$text = $this->load->view('mail/webhost/lock', $mailData);
			
					$mailLib->setText($text);
					$mailLib->send();
					
					echo "Веб-хостинг: ws" . $webid . " - заблокирован.\n";
				}
			} else {
				if($diff->days < 3) {
					$mailLib->setTo($item['user_email']);
					$mailLib->setSubject("Завершение оплаченного периода веб-хостинга #$webid");
					
					$mailData = array();
					$mailData['firstname'] = $item['user_firstname'];
					$mailData['lastname'] = $item['user_lastname'];
					$mailData['webid'] = $webid;
					$mailData['days'] = $diff->days;
			
					$text = $this->load->view('mail/webhost/needPay', $mailData);
			
					$mailLib->setText($text);
					$mailLib->send();
					
					echo "Веб-хостинг: ws" . $webid . " - отправлено уведомление.\n";
				}
			}
		}

		$getData = array('invoice_status' => 0 );
        $invoices = $this->invoicesModel->getInvoices($getData, array(), array(), $options);
		foreach($invoices as $item) {
		$invoiceid = $item['invoice_id'];
		$this->invoicesModel->deleteInvoice($invoiceid);
		}
		return null;
	}
	
	public function updateSystemLoad() {
		$this->load->model('servers');
		$this->load->model('serverLog');
		$this->load->library('ssh2');
		$token = @$this->request->get['token'];
		if($this->config->token != $token) {
			return "Access Denied";
		}
		$servers = $this->serversModel->getServers(array(), array('games', 'users', 'locations'));
		
		foreach($servers as $item) {
			$serverid = $item['server_id'];
				
			if($item['server_status'] == 2) {
				$sysload = $this->serversModel->getServerSystemLoad($serverid);
				$hdd = round($sysload['ssd']);
				$cpu = round($sysload['cpu']);
				$ram = $sysload['ram'] > 100 ? 100 : round($sysload['ram']);

				$today = date("Y-m-d H:i:s");
				$this->serversModel->updateServer($serverid, array(
					'server_cpu_load'		=>	$cpu,
					'server_ram_load'		=>	$ram,
					'server_ssd_load'		=>	$hdd,
					'server_ram_cpu_date'	=>	$today,
					'server_ssd_date'	=>	$today
				));
			} else {
				$sysload = $this->serversModel->getServerSystemLoad($serverid);
				$hdd = round($sysload['ssd']);
				$today = date("Y-m-d H:i:s");
				$this->serversModel->updateServer($serverid, array(
					'server_cpu_load'		=>	0,
					'server_ram_load'		=>	0,
					'server_ssd_load'		=>	$hdd,
					'server_ram_cpu_date'	=>	$today,
					'server_ssd_date'		=>	$today
				));				
			}
		}			
		return null;
	}
	
	public function gameServers() {
		$this->load->model('servers');
		$this->load->model('serverLog');
		$this->load->library('ssh2');
		$token = @$this->request->get['token'];
		if($this->config->token != $token) {
			return "Access Denied";
		}
		$servers = $this->serversModel->getServers(array(), array('games', 'users', 'locations'));
		
		foreach($servers as $item) {
			$serverid = $item['server_id'];
				
			if($item['server_status'] == 3) {
				$this->serversModel->action($serverid, "install");
				echo "Игровой сервер: gs" . $serverid . " - успешная установка.\n";
				$logData = array(
					'server_id'			=> $serverid,
					'reason'            => 'Успешная установка сервера.',
					'status'            => 1
				);
				$this->serverLogModel->createLog($logData);
			}
			if($item['server_status'] == 4) {
				$this->serversModel->action($serverid, "reinstall");	
				echo "Игровой сервер: gs" . $serverid . " - успешная переустановка.\n";
				$logData = array(
					'server_id'			=> $serverid,
					'reason'            => 'Успешная переустановка сервера.',
					'status'            => 1
				);
				$this->serverLogModel->createLog($logData);
			}
			if($item['server_status'] == 5) {
				$this->serversModel->action($serverid, 'createbackup');
				echo "Игровой сервер: gs" . $serverid . " - успешный бекап.\n";
				$logData = array(
					'server_id'			=> $serverid,
					'reason'            => 'Успешное создание BackUP.',
					'status'            => 1
				);
				$this->serverLogModel->createLog($logData);
			}
			if($item['server_status'] == 6) {
				$this->serversModel->action($serverid, "installbackup");		
				echo "Игровой сервер: gs" . $serverid . " - успешное восстановление из бекапа.\n";
				$logData = array(
					'server_id'			=> $serverid,
					'reason'            => 'Успешное восстановление из BackUP.',
					'status'            => 1
				);
				$this->serverLogModel->createLog($logData);
			}
		}			
		return null;
	}
	
	public function gamelocationstatsupd()
	{
		$token = @$this->request->get['token'];
		if($this->config->token != $token) {
			return "Access Denied";
		}

		$this->load->model('locations');
		$this->load->library('ssh2');
		$ssh2Lib = new ssh2Library();
		$this->load->model('locations');
		
		$locations = $this->locationsModel->getLocations(array(), array(), array());
		
		$today = date("Y-m-d H:i:s");

		foreach ($locations as $item) {
			if($item['location_status'] == 1) {
				$link = $ssh2Lib->connect($item['location_ip'], $item['location_user'], $item['location_password']);
				
				$cpu = (int) $ssh2Lib->execute($link, 'echo $[100-$(vmstat 1 2|tail -1|awk \'{print $15}\')]');
				
				$hdd_free = (int) $ssh2Lib->execute($link, 'df -h -B 1M $HOME | grep dev | awk \'{print $4}\'');
				$hdd_used = (int) $ssh2Lib->execute($link, 'df -h -B 1M $HOME | grep dev | awk \'{print $3}\'');
				$hdd_all = (int) $ssh2Lib->execute($link, 'df -h -B 1M $HOME | grep dev | awk \'{print $2}\'');
				
				$ram_all = (int) $ssh2Lib->execute($link, 'cat /proc/meminfo | grep MemTotal | awk \'{print $2}\'');
				$ram_free = (int) $ssh2Lib->execute($link, 'cat /proc/meminfo | grep MemAvailable | awk \'{print $2}\'');
				$ram_used = (int) $ram_all - (int) $ram_free;
				
				$swap_all = (int) $ssh2Lib->execute($link, 'cat /proc/meminfo | grep SwapTotal | awk \'{print $2}\'');
				$swap_free = (int) $ssh2Lib->execute($link, 'cat /proc/meminfo | grep SwapFree | awk \'{print $2}\'');
				$swap_used = (int) $swap_all - (int) $swap_free;
				
				$ssh2Lib->disconnect($link);

				$locationData = array(
					'location_cpu'			=> $cpu,
					'location_ram'			=> round($ram_used * 0.000977, 0),
					'location_ramold'		=> round($ram_all * 0.000977, 0),
					'location_swap'			=> round($swap_used * 0.000977, 0),
					'location_swapold'		=> round($swap_all * 0.000977, 0),
					'location_hdd'			=> $hdd_used,
					'location_hddold'		=> $hdd_all,
					'location_upd'		    => $today
				);				
				$this->locationsModel->updateLocation($item['location_id'], $locationData);		
				echo 'Обновлена информация локации #'. $item['location_id'] .'. CPU: ' . $cpu . '%, RAM: ' . round($ram_used * 0.000977, 0) . 'МБ/' . round($ram_all * 0.000977, 0) . 'МБ, SWAP: ' . round($swap_used * 0.000977, 0) . 'МБ/' . round($swap_all * 0.000977, 0) . 'МБ, SSD: ' . $hdd_used . 'МБ/' . $hdd_all . 'МБ.\n';
			}
			if($item['location_status'] == 0) {
				$locationData = array(
					'location_cpu'			=> 0,
					'location_ram'			=> 0,
					'location_ramold'		=> 0,
					'location_swap'			=> 0,
					'location_swapold'		=> 0,
					'location_hdd'			=> 0,
					'location_hddold'		=> 0,
					'location_upd'		    => $today
				);				
				$this->locationsModel->updateLocation($locationid, $locationData);
			}
		}
	}
	
	public function updateStats() {
		$this->load->library('query');
		$this->load->model('servers');
		$this->load->model('serversStats');
		$this->load->model('serverLog');
		
		$token = @$this->request->get['token'];
		if($this->config->token != $token) {
			return "Access Denied";
		}
		
		$servers = $this->serversModel->getServers(array(), array('games', 'locations'));
	
		$this->serversStatsModel->clearServersStats();
		
		foreach($servers as $item) {
			$serverid = $item['server_id'];
			
			if($item['server_status'] == 2) {
				$queryLib = new queryLibrary($item['game_query']);
				$queryLib->connect($item['location_ip'], $item['server_port']);
				$query = $queryLib->getInfo();
				$queryLib->disconnect();
				
				$sysload = $this->serversModel->getServerSystemLoad($serverid);
				$hdd = round($sysload['ssd']);
				$cpu = round($sysload['cpu']);
				$ram = round($sysload['ram']);				
				
				$this->serversStatsModel->createServerStats(array(
					'server_id'				=> $serverid,
					'server_stats_players'	=> round($query['players']),
					'server_stats_cpu'		=> $cpu,
					'server_stats_ram'		=> $ram,
					'server_stats_hdd'		=> $hdd								
				));	
			}
		}
		return null;
	}
	
	public function stopServers() {
		$this->load->model('servers');
		$this->load->model('serverLog');
		
		$token = @$this->request->get['token'];
		if($this->config->token != $token) {
			return "Access Denied";
		}
		
		$servers = $this->serversModel->getServers(array(), array('games', 'locations'));
		
		foreach($servers as $item) {
			$serverid = $item['server_id'];
			
			if($item['server_status'] == 2) {
				$sysload = $this->serversModel->getServerSystemLoad($serverid);
				$hdd = round($sysload['ssd']);
				$cpu = round($sysload['cpu']);
				$ram = round($sysload['ram']);				

				$cpu_end = $item['game_cores'] * 100;
				if($cpu > $cpu_end) {
					$connect = $this->serversModel->action($serverid, 'stop');
					if($connect['status'] == "success") {		
						$this->serversModel->updateServer($serverid, array('server_status' => 1));
						$logData = array(
							'server_id'			=> $serverid,
							'reason'            => "Остановка сервера: OVERLOAD-cpu = ".$cpu."/".$cpu_end."%",
							'status'            => 1
						);
						$this->serverLogModel->createLog($logData);
						echo "Остановка сервера: OVERLOAD-cpu = ".$cpu."/".$cpu_end."% \n";	
					} else {							
						echo "Ошибка остановки сервера gs$item[server_id] \n";	
					}
				}elseif($ram > 100){
					$connect = $this->serversModel->action($serverid, 'stop');
					if($connect['status'] == "success") {		
						$this->serversModel->updateServer($serverid, array('server_status' => 1));
						$logData = array(
							'server_id'			=> $serverid,
							'reason'            => "Остановка сервера: OVERLOAD-ram = ".$ram."/100%",
							'status'            => 1
						);
						$this->serverLogModel->createLog($logData);
						echo "Остановка сервера: OVERLOAD-ram = ".$ram."/100% \n";	
					} else {							
						echo "Ошибка остановки сервера gs$item[server_id] \n";	
					}
				}elseif($hdd > $item['game_ssd']){
					$connect = $this->serversModel->action($serverid, 'stop');
					if($connect['status'] == "success") {		
						$this->serversModel->updateServer($serverid, array('server_status' => 1));
						$logData = array(
							'server_id'			=> $serverid,
							'reason'            => "Остановка сервера: OVERLOAD-ssd = ".$hdd."/".$item['game_ssd']."МБ",
							'status'            => 1
						);
						$this->serverLogModel->createLog($logData);
						echo "Остановка сервера: OVERLOAD-ssd = ".$hdd."/".$item['game_ssd']."МБ \n";	
					} else {							
						echo "Ошибка остановки сервера gs$item[server_id] \n";	
					}
				}
				
			}
		}
		return null;
	}

	public function stopServersQuery() {
		$this->load->library('query');
		$this->load->model('servers');
		$this->load->model('serverLog');
		
		$token = @$this->request->get['token'];
		if($this->config->token != $token) {
			return "Access Denied";
		}
		
		$servers = $this->serversModel->getServers(array(), array('games', 'locations'));
		
		foreach($servers as $item) {
			$serverid = $item['server_id'];
			
			if($item['server_status'] == 2) {
				$queryLib = new queryLibrary($item['game_query']);
				$queryLib->connect($item['location_ip'], $item['server_port']);
				$query = $queryLib->getInfo();
				$queryLib->disconnect();	
				
				if($query['players'] > ($item['server_slots']+1)){
					$connect = $this->serversModel->action($serverid, 'stop');
					if($connect['status'] == "success") {			
						$this->serversModel->updateServer($serverid, array('server_status' => 1));
						$logData = array(
							'server_id'			=> $serverid,
							'reason'            => "Остановка сервера: Чрезмерное кол.во игроков на сервере, игроков ".$query['players']." слотов ".$item['server_slots']."",
							'status'            => 1
						);
						$this->serverLogModel->createLog($logData);
						echo "Остановка сервера: Чрезмерное кол.во игроков на сервере, игроков ".$query['players']." слотов ".$item['server_slots']." \n";	
					} else {							
						echo "Ошибка остановки сервера gs$item[server_id] \n";
					}
				}	
			}
		}
		return null;
	}

	public function serverReloader() {
        $this->load->model('servers');
        $this->load->model('locations');
        $this->load->model('serverLog');
	
	    $token = @$this->request->get['token'];
	    if($this->config->token != $token) {
	        return "Access Denied";
	    }	
	
	    $locations = $this->locationsModel->getLocations(array());
	
	    foreach($locations as $location) {	
			echo '<br> Локация ('.$location['location_id'].') '.$location['location_name'].' <br>';
			$servers = $this->serversModel->getServers(array('server_status' => '2', 'location_id' => $location['location_id']));
			if($servers){
				foreach($servers as $item) {
					$serverid = $item['server_id'];
					$result = $this->serversModel->action($serverid, 'server_status');
					
					if($result == 1) {								
						$this->serversModel->action($serverid, 'stop');
						$this->serversModel->action($serverid, 'start');
						$logData = array(
							'server_id'			=> $serverid,
							'reason'            => 'Сервер был восcтановлен после падения',
							'status'            => 1
						);
						$this->serverLogModel->createLog($logData);				
						echo "<br>Игровой сервер gs$item[server_id] - Поднят. \n";								
					}
				}					
			}
	    }
		return null;
	}
	
	public function clearLogs() {
		$this->load->model('waste');
		$this->load->model('serverLog');
		$token = @$this->request->get['token'];
		if($this->config->token != $token) {
			return "Access Denied";
		}
		
		$wasteLogs = $this->wasteModel->getWaste();
		$serverLogs = $this->serverLogModel->getLogs();
		
		$datenow = date_create('now');
		
		foreach($serverLogs as $item) {
			$diff = date_diff($datenow, date_create($item['date']));
			
			if($diff->invert) {
				if($diff->days >= 7) {
					$this->serverLogModel->deleteLog($item['log_id']);
				}
			}
		}
		
		foreach($wasteLogs as $item) {
			$diff = date_diff($datenow, date_create($item['waste_date_add']));
			
			if($diff->invert) {
				if($diff->days >= 7) {
					$this->wasteModel->deleteWaste($item['waste_id']);
				}
			}
		}

		return null;
	}
}
?>
