<?php
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)

Developed by Andrey Chikaev (https://vk.com/winchikplay)

*/
class minepeController extends Controller {
	public function index($page = 1) {
		$this->document->setActiveSection('monitoring');
		$this->document->setActiveItem('minepe');
		$this->load->library('query');
		$this->load->model('serversStats');
		$this->load->library('pagination');
		$this->load->model('servers');
		$getData = array('server_status' => 2);
		
		if(isset($this->request->get['gameid'])) {
			$getData['servers.game_id'] = (int)$this->request->get['gameid'];
		}
		
		if(isset($this->request->get['locationid'])) {
			$getData['servers.location_id'] = (int)$this->request->get['locationid'];
		}
		$getOptions = array(
			'start' => ($page - 1) * $this->limit,
			'limit' => $this->limit
		);

		$total = $this->serversModel->getTotalServers($getData);
		$servers = $this->serversModel->getServers($getData, array('games', 'locations'),array(),  $getOptions);
		$paginationLib = new paginationLibrary();
		
		$paginationLib->total = $total;
		$paginationLib->page = $page;
		$paginationLib->limit = $this->limit;
		$paginationLib->url = $this->config->url . 'monitoring/minepe/index/{page}';
		
		$pagination = $paginationLib->render();
		$this->data['servers'] = $servers;
		$this->data['pagination'] = $pagination;
		$this->getChild(array('common/header', 'common/footer', 'common/hostingames'));
		return $this->load->view('monitoring/minepe', $this->data);
	}
}
?>
