<?php
/*
Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Andrey Chikaev (https://vk.com/winchikplay)
*/
class autoinstallController extends Controller {
	public function index($serverid = null) {
		$this->document->setActiveSection('servers');
		$this->document->setActiveItem('autoinstall');
		
		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		if($this->user->getAccessLevel() < 0) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		
		$this->load->model('servers');
		$this->load->model('mods');
		$this->load->model('users');

		$error = $this->validate($serverid);
		if($error) {
			$this->session->data['error'] = $error;
			$this->response->redirect($this->config->url . 'servers/index');
		}
		
		$userid = $this->user->getId();
		
		$server = $this->serversModel->getServerById($serverid, array('games', 'locations'));
		$this->data['server'] = $server;

		$mods = $this->modsModel->getMods(array('mod_status' => 1),array('games'),array(), array());
		$this->data['usermods'] = $this->usersModel->getUserMods($userid);
        $this->data['mods'] = $mods;
		
		include_once 'application/controllers/common/main.php';
		
		$this->getChild(array('common/footer'));
		return $this->load->view('servers/autoinstall', $this->data);
	}
	
	public function action($serverid = null, $action = null) {
		if(!$this->user->isLogged()) {
			$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 0) {
	  		$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		$userid = $this->user->getId();
		$this->load->model('servers');
		$this->load->library('ssh2');
		$this->load->model('mods');
		$this->load->model('users');
		$this->load->model('waste');
		$ssh2Lib = new ssh2Library();
		
		$error = $this->validate($serverid);
		if($error) {
			$this->data['status'] = "error";
			$this->data['error'] = $error;
			return json_encode($this->data);
		}	
		$balance = $this->user->getBalance();
		$server = $this->serversModel->getServerById($serverid, array('users', 'locations', 'games'));

		if($server["server_status"] == 0) {
			$this->data["status"] = "error";
			$this->data["error"] = "Сервер заблокирован!";
			return json_encode($this->data);
		}
		
        $link = $ssh2Lib->connect($server['location_ip'], $server['location_user'], $server['location_password']);
        $mods = $this->modsModel->getMods(array(),array('games'),array(), $options);
		$stats = $this->serversModel->getHDD($server['server_id']);
		foreach($mods as $item){
			if($stats > $server['game_ssd']) {
				$this->data["status"] = "error";
				$this->data["error"] = "Вы привысили ограничение размера директории на ". round($stats - $server['game_ssd'], 2) ."МБ, установка мода невозможна!";
				$today = date("Y-m-d H:i:s");
				$this->serversModel->updateServer($serverid, array('server_ssd_load' => (int)$stats, 'server_ssd_date'   =>	$today));
				return json_encode($this->data);
			}
			if($server['server_mysql'] == 0) {
					$this->data['status'] = "error";
					$this->data['error'] = "Создайте базу MySQL и включите его [Меню слева]!";	
					return json_encode($this->data);		
			}
			if($action == $item['mod_id']) {
				if($server['server_status'] == 1) {
					if($item['mod_price'] > 0) {
						if($this->usersModel->checkFreeMode($userid, $item['mod_id'])){
							$free_mode = 1;
						}
						$price = $item['mod_price'];
						if(($balance < $price) and $free_mode != 1){
							$this->data['status'] = "error";
							$this->data['error'] = "Недостаточно средств";
							return json_encode($this->data);
						}
					}
					$this->serversModel->action($serverid, 'reinstall');
					$host = $server['location_ip'];
					$uname = "gs$serverid";
					$dbpass = $server['db_pass'];
					$database = "gs$serverid"; 
					$conn = new mysqli($host, $uname, $dbpass, $database);
					$op_data = '';
					if ($mresult = $conn->query("SHOW TABLES"))
					{
						while($row = $mresult->fetch_array(MYSQLI_NUM))
						{
							$conn->query('DROP TABLE IF EXISTS '.$row[0]);
						}
					}	
					$FILE = "scriptfiles/mysql_settings.ini";
					$output = $ssh2Lib->execute($link, 
						"
							cd /home/gs$serverid;	
							rm server.cfg;
							rm -rf gamemodes;
							rm -rf filterscripts;
							rm -rf include;
							rm -rf npcmodes;
							rm -rf scriptfiles;
							wget ".$item['mod_url'].";
							tar -xf ".$item['mod_arch'].";
							rm ".$item['mod_arch'].";							
							mysql -h".$server['location_ip']." -u gs$serverid -p".$server['db_pass']." gs$serverid < dump.sql;
							rm dump.sql;
							echo 'host = ".$server['location_ip']."'>>".$FILE.";
							echo 'username = gs$serverid'>>".$FILE.";
							echo 'password = ".$server['db_pass']."'>>".$FILE.";
							echo 'database = gs$serverid'>>".$FILE.";
							sudo chown -R gs". $server['server_id'] .":gameservers /home/gs". $server['server_id'] ."	
						"
					);
					$ssh2Lib->disconnect($link);;
					$result = $this->serversModel->action($serverid, 'start');
					if($result['status'] == "success") {
						if($item['mod_price'] > 0) {
							if($free_mode != 1){
								$userid = $this->user->getId();
								$wasteData = array(
								  'user_id'			=> $userid,
								  'waste_ammount'	=> $price,
								  'waste_status'	=> 1,
								  'waste_usluga'	=> "Установка мода ".$item['mod_name'].""
								); 
								$this->wasteModel->createWaste($wasteData);
								$this->usersModel->downUserBalance($userid, $price);
								$this->serversModel->updateServer($serverid, array('server_status' => 2));
								$freeData = array(
								  'user_id'			=> $userid,
								  'mod_id'			=> "".$item['mod_id'].""
								); 
								$this->usersModel->addMode($freeData);
								
								$user = $this->usersModel->getUserById($userid, array(), array(), array());
								
								if($user['ref'] != 0) {								
									$ref_percent = $this->config->ref_percent;
									$getpref = ($price * (1 + $ref_percent / 100)) - $price;
									$this->usersModel->upUserBalance($user['ref'], $getpref);
									$this->usersModel->upUserRMoney($user['ref'], $getpref);
														
									$wasteData = array(
										'user_id'		=> $user['ref'],
										'waste_ammount'	=> $getpref,
										'waste_status'	=> 0,
										'waste_usluga'	=> "Бонус с реферала ID-$userid"
									); 
									$this->wasteModel->createWaste($wasteData);
								}
				
								$this->data['status'] = "success";
								$this->data['success'] = "Вы успешно установили ".$item['mod_name']." с вашего счёта снято ".$item['mod_price']." р!";	
							} else{
								$this->serversModel->updateServer($serverid, array('server_status' => 2));
								$this->data['status'] = "success";
								$this->data['success'] = "Вы успешно установили ".$item['mod_name'];
							}
						} else {
							$this->serversModel->updateServer($serverid, array('server_status' => 2));
							$this->data['status'] = "success";
							$this->data['success'] = "Вы успешно установили ".$item['mod_name']."!";
						}
						$stats2 = $this->serversModel->getHDD($server['server_id']);		
						$today = date("Y-m-d H:i:s");
						$this->serversModel->updateServer($serverid, array('server_ssd_load' => (int)$stats2, 'server_ssd_date'   =>	$today));
					} else {
						$this->data['status'] = "error";
						$this->data['error'] = $result['description'];
					}
				} else {
					$this->data['status'] = "error";
					$this->data['error'] = "Сервер должен быть выключен!";
				}
				break;
			}
		}
		return json_encode($this->data);
	}

	private function validate($serverid) {
		$result = null;
		
		$userid = $this->user->getId();
		
		if(!$this->serversModel->getTotalServerOwners(array('server_id' => (int)$serverid, 'user_id' => (int)$userid, 'owner_status' => 1))) {
			if(!$this->serversModel->getTotalServers(array('server_id' => (int)$serverid, 'user_id' => (int)$userid))) {
				$result = "Запрашиваемый сервер не существует!";
			}
		}
		return $result;
	}
}
?>