<?php
/*
Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Andrey Chikaev (https://vk.com/winchikplay)
*/
class controlController extends Controller {
	public function index($serverid = null) {
		$this->document->setActiveSection('servers');
		$this->document->setActiveItem('control');

		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		if($this->user->getAccessLevel() < 0) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}	
		
		$this->load->library('query');
		$this->load->model('servers');
		
		$error = $this->validate($serverid);
		if($error) {
			$this->session->data['error'] = $error;
			$this->response->redirect($this->config->url . 'servers/index');
		}
		
		$server = $this->serversModel->getServerById($serverid, array('games', 'locations'));

		$datenow = date_create('now');
		$dateend = date_create($server['server_date_end']);
		$diff = date_diff($datenow, $dateend);

		if ($diff->invert) {
			$days = 1;
		} else {
			$days = $diff->days;
		}
		
		if($server['server_status'] == 2) {
			$queryLib = new queryLibrary($server['game_query']);
			$queryLib->connect($server['location_ip'], $server['server_port']);
			$query = $queryLib->getInfo();
			$queryLib->disconnect();
			
			$this->data['query'] = $query;
		}
		
		if($server['server_status'] == 2 AND $server['game_code'] == "cs" || $server['game_code'] == "css" || $server['game_code'] == "csgo") {
			$this->load->library('ssh2');
				
			$ssh = new ssh2Library();
			$connect = $ssh->connect($server['location_ip'], $server['location_user'], $pass = $server['location_password']);
			$output = $ssh->execute($connect, "cd /home/gs".$server['server_id']."/cstrike/maps/; ls | grep .bsp;");
			$disconnect = $ssh->disconnect($connect);
			$data = $output . $disconnect;
			$data = explode("\n", $data);
			
			$maps = '<option selected="selected" value="' . $query['mapname'] . '">' . $query['mapname'] . '</option>';
			
			foreach ($data as $map) {
				if (!preg_match('/\.(bsp.ztmp)/', $map)) {
					$map = str_replace(".bsp", "", $map);
					$maps .= '<option value="' . $map . '">' . $map . '</option>';
				}
			}
			$this->data['maps'] = $maps;			
		}
		
		$this->data['server'] = $server;
		$this->data['days'] = $days;
		$this->data['portPrice'] = $portPrice = round($this->config->portPrice);

		include_once 'application/controllers/common/main.php';
		
		$this->getChild(array('common/header', 'common/footer'));
		return $this->load->view('servers/control', $this->data);
	}
	
	public function ajax($serverid = null) {
		if(!$this->user->isLogged()) {  
	  		$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		
		if($this->user->getAccessLevel() < 1) {
	  		$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		
		$this->load->model('waste');
		$this->load->model('users');
		$this->load->model('servers');
		$this->load->model('serverLog');
		
		$server = $this->serversModel->getServerById($serverid, array('games'));
		
		$error = $this->validate($serverid);
		if($error) {
			$this->data['status'] = "error";
			$this->data['error'] = $error;
			return json_encode($this->data);
		}	
		
		if($server["server_status"] == 0) {
			$this->data["status"] = "error";
			$this->data["error"] = "Сервер заблокирован!";
			return json_encode($this->data);
		}
		
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$errorPOST = $this->validatePOST($serverid);
			if(!$errorPOST) {
				$slots = $this->request->post['slots'];
				$userid = $this->user->getId();
				$balance = $this->user->getBalance();
				$user = $this->usersModel->getUserById($userid, array(), array(), array());
				
				$datenow = date_create('now');
				$dateend = date_create($server['server_date_end']);
				$diff = date_diff($datenow, $dateend);

				if ($diff->invert) {
					$days = 1;
				}
				else {
					$days = $diff->days;
				}
				$price = $server['game_price'] * ($slots-$server['server_slots']);

				if ($days != NULL) {
					$price = ($price / 30) * $days;
				}
				
				if ($server['server_slots'] == $slots) {
					$price = '0';
				}

				if (($slots - $server['server_slots']) <= 0) {
					$price = '0';
				}
				
				if($slots < $server['server_slots'])
				{
					$this->data['status'] = "error";
					$this->data['error'] = "Невозможно установить слоты ниже заданных.";
					return json_encode($this->data);			
				}				
				if($slots == $server['server_slots'])
				{
					$this->data['status'] = "success";
					$this->data['success'] = "Слоты не были изменены.";
					return json_encode($this->data);			
				}
				if($balance >= $price) {
					$this->serversModel->slotsServer($serverid, $slots);
					$this->usersModel->downUserBalance($userid, round($price, 2));
					$wasteData = array(
						'user_id'		=> $userid,
						'waste_ammount'	=> round($price, 2),
						'waste_status'	=> 1,
						'waste_usluga'	=> "Увеличено до $slots слотов для сервера gs$serverid"
					 ); 	
					$this->wasteModel->createWaste($wasteData);
	
					if($user['ref'] != 0) {
						$ref_percent = $this->config->ref_percent;
						$getpref = ($price * (1 + $ref_percent / 100)) - $price;
						$this->usersModel->upUserBalance($user['ref'], $getpref);
						$this->usersModel->upUserRMoney($user['ref'], $getpref);
							
						$wasteData = array(
							'user_id'		=> $user['ref'],
							'waste_ammount'	=> $getpref,
							'waste_status'	=> 0,
							'waste_usluga'	=> "Бонус с реферала ID-$userid"
						); 
						$this->wasteModel->createWaste($wasteData);
					}
						
					$logData = array(
						'server_id'			=> $serverid,
						'reason'            => 'Изменено количество слотов.',
						'status'            => 1
					);
					$this->serverLogModel->createLog($logData);

					$this->data['status'] = "success";
					$this->data['success'] = "Установлено $slots слотов! (- ".round($price, 2)." руб.)";
				} else {
					$this->data['status'] = "error";
					$logData = array(
						'server_id'			=> $serverid,
						'reason'            => '[SLOTS] Не достаточно средств!',
						'status'            => 3
					);
					$this->serverLogModel->createLog($logData);
					$this->data['error'] = "На Вашем счету не хватает ". round($price - $balance, 2) ." руб.";
				}
			} else {
				$this->data['status'] = "error";
				$this->data['error'] = $errorPOST;
			}
		}
		return json_encode($this->data);
	}
	
	public function action($serverid = null, $action = null) {
		if(!$this->user->isLogged()) {
			$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 0) {
	  		$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		
		$this->load->model('servers');
		$this->load->model('serverLog');
		$this->load->library('ssh2');
		$ssh2Lib = new ssh2Library();
					
		$server = $this->serversModel->getServerById($serverid, array('users', 'locations', 'games'));		
		
		$error = $this->validate($serverid);
		if($error) {
			$this->data['status'] = "error";
			$this->data['error'] = $error;
			return json_encode($this->data);
		}	
		
		if($server["server_status"] == 0) {
			$this->data["status"] = "error";
			$this->data["error"] = "Сервер заблокирован!";
			return json_encode($this->data);
		}
		
		switch($action) {
			case "start": {
				if($server["server_status"] == 1) {
					$stats = $this->serversModel->getHDD($server['server_id']);
					if((int)$stats < $server['game_ssd']) {
						$result = $this->serversModel->action($serverid, 'start');
						if($result["status"] == "success") {
							$this->serversModel->updateServer($serverid, array("server_status" => 2));
							$logData = array(
								'server_id'			=> $serverid,
								'reason'            => 'Успешный запуск сервера',
								'status'            => 1
							);
							$this->serverLogModel->createLog($logData);
							$today = date("Y-m-d H:i:s");
							$this->serversModel->updateServer($serverid, array('server_ssd_load' => (int)$stats, 'server_ssd_date'   =>	$today));
							$this->data["status"] = "success";
							$this->data["success"] = "Вы успешно запустили сервер!";
						} else {
							$this->data["status"] = "error";
							$this->data["error"] = $result["description"];
						}
					} else {
						$this->data["status"] = "error";
						$this->data["error"] = "Вы привысили ограничение размера директории на ". round($stats - $server['game_ssd'], 2) ."МБ, запуск сервера невозможен!";
					}
				} else if($server["server_status"] == 0) {
					$this->data["status"] = "error";
					$this->data["error"] = "Сервер не оплачен!";
				} else if($server["server_status"] == 2) {
					$this->data["status"] = "error";
					$this->data["error"] = "Сервер должен быть выключен!";
				} else if($server["server_status"] == 0) {
					$this->data["status"] = "error";
					$this->data["error"] = "Сервер заблокирован!";
				}
				break;
			}
				
			case "reinstall": {
				if($server["server_status"] == 1) {
					$logData = array(
						'server_id'			=> $serverid,
						'reason'            => 'Сервер успешно поставлен на переустановку!',
						'status'            => 2
					);
                    $this->serverLogModel->createLog($logData);
					$this->serversModel->updateServer($serverid, array('server_status' => 4));
					$this->data["status"] = "success";
					$this->data["success"] = "Сервер успешно поставлен на переустановку!";
				} else if($server["server_status"] == 2) {
					$this->data["status"] = "error";
					$this->data["error"] = "Сервер должен быть выключен!";
				} else if($server["server_status"] == 0) {
					$this->data["status"] = "error";
					$this->data["error"] = "Сервер заблокирован!";
				}
				break;
			}
				
			case "restart": {
				if($server["server_status"] == 2) {
					$stats = $this->serversModel->getHDD($server['server_id']);
					if((int)$stats < $server['game_ssd']) {
						$this->serversModel->action($serverid, 'stop');
						$result = $this->serversModel->action($serverid, 'start');
						if($result["status"] == "success") {
							$logData = array(
								'server_id'			=> $serverid,
								'reason'            => 'Успешный перезапуск сервера',
								'status'            => 1
							);
							$this->serverLogModel->createLog($logData);
							$today = date("Y-m-d H:i:s");
							$this->serversModel->updateServer($serverid, array('server_ssd_load' => (int)$stats, 'server_ssd_date'   =>	$today));
							$this->data["status"] = "success";
							$this->data["success"] = "Вы успешно перезапустили сервер!";
						} else {
							$this->data["status"] = "error";
							$this->data["error"] = $result["description"];
						}
					} else {
						$result = $this->serversModel->action($serverid, 'stop');
						if($result['status'] == "success") {
							$this->serversModel->updateServer($serverid, array('server_status' => 2));
							$this->data["status"] = "error";
							$this->data["error"] = "Вы привысили ограничение размера директории на ". round($stats - $server['game_ssd'], 2) ."МБ, перезагрузка сервера невозможен!";
						} else {
							$this->data["status"] = "error";
							$this->data["error"] = $result["description"];
						}
					}
				} else if($server["server_status"] == 2) {
					$this->data["status"] = "error";
					$this->data["error"] = "Сервер должен быть выключен!";
				} else if($server["server_status"] == 0) {
					$this->data["status"] = "error";
					$this->data["error"] = "Сервер заблокирован!";
				}
				break;
			}
			
			case "stop": {
				if($server["server_status"] == 2) {
					$result = $this->serversModel->action($serverid, 'stop');
					if($result["status"] == "success") {
						$this->serversModel->updateServer($serverid, array("server_status" => 1));
						$logData = array(
							'server_id'			=> $serverid,
							'reason'            => 'Успешное выключение сервера',
							'status'            => 1
						);
                        $this->serverLogModel->createLog($logData);	
						$stats = $this->serversModel->getHDD($server['server_id']);
						$today = date("Y-m-d H:i:s");
						$this->serversModel->updateServer($serverid, array('server_ssd_load' => (int)$stats, 'server_ssd_date'   =>	$today));
						$this->data["status"] = "success";
						$this->data["success"] = "Вы успешно выключили сервер!";
					} else {
						$this->data["status"] = "error";
						$this->data["error"] = $result["description"];
					}
				} else if($server["server_status"] == 2) {
					$this->data["status"] = "error";
					$this->data["error"] = "Сервер должен быть выключен!";
				} else if($server["server_status"] == 0) {
					$this->data["status"] = "error";
					$this->data["error"] = "Сервер заблокирован!";
				}
				break;
			}

			case 'backup': {
				if($server['server_status'] == 1) {
					$stats = $this->serversModel->getHDD($server['server_id']);
					if((int)$stats < $server['game_ssd']) {
						$this->serversModel->updateServer($serverid, array('server_status' => 5));
						$logData = array(
							'server_id'			=> $serverid,
							'reason'            => 'Успешное начало создания BackUP сервера.',
							'status'            => 1
						);
						$this->serverLogModel->createLog($logData);
						$this->data['status'] = "success";
						$this->data['success'] = "Вы успешно начали создание BackUP сервера!";
					} else {
						$this->data["status"] = "error";
						$this->data["error"] = "Вы привысили ограничение размера директории на ". round($stats - $server['game_ssd'], 2) ."МБ, создание бекапа сервера невозможено!";
					}
				} else {
					$this->data['status'] = "error";
					$this->data['error'] = "Сервер должен быть выключен!";
				}
				break;
			}
			
			case 'unbackup': {
				if($server['server_status'] == 1) {
					if (file_exists('ssh2.sftp://'.$server['location_user'].':'.$server['location_password'].'@'.$server['location_ip'].':22/home/cp/backups/gs'.$serverid.'.tar')) {
						$result = $this->serversModel->action($serverid, 'installbackup');
						$this->serversModel->updateServer($serverid, array('server_status' => 6));
						$logData = array(
							'server_id'			=> $serverid,
							'reason'            => 'Успешное начало восстановление BackUP сервера.',
							'status'            => 1
						);
						$this->serverLogModel->createLog($logData);
						$stats = $this->serversModel->getHDD($server['server_id']);		
						$today = date("Y-m-d H:i:s");
						$this->serversModel->updateServer($serverid, array('server_ssd_load' => (int)$stats, 'server_ssd_date'   =>	$today));
						$this->data['status'] = "success";
						$this->data['success'] = "Вы успешно восстановили BackUP сервера!";
					} else {
						$this->data['status'] = "error";
						$this->data['error'] = "У вас нет BackUP сервера!";
					}
				} else {
					$this->data['status'] = "error";
					$this->data['error'] = "Сервер должен быть выключен!";
				}
				break;
			}
			default: {
				$logData = array(
					'server_id'			=> $serverid,
					'reason'            => 'Вы выбрали несуществующее действие!',
					'status'            => 3
				);
                $this->serverLogModel->createLog($logData);
				
				$this->data['status'] = "error";
				$this->data['error'] = "Вы выбрали несуществующее действие!";
				break;
			}
		}
		return json_encode($this->data);
	}
	
	public function ajax_port($serverid = null) {
		if(!$this->user->isLogged()) {
			$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		
		if($this->user->getAccessLevel() < 1) {
			$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}

		$userid = $this->user->getId();
		$balance = $this->user->getBalance();
		$portPrice = round($this->config->portPrice);

		$this->load->model('users');
		$this->load->model('waste');
		$this->load->model('servers');
		$this->load->model('serversFirewalls');

		$gameServer = $this->serversModel->getServerById($serverid, array('games', 'locations'));
		
		$error = $this->validate($serverid);
		if($error) {
			$this->data['status'] = "error";
			$this->data['error'] = $error;
			return json_encode($this->data);
		}	
		
		if($gameServer["server_status"] == 0) {
			$this->data["status"] = "error";
			$this->data["error"] = "Сервер заблокирован!";
			return json_encode($this->data);
		}
			
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$port = @(int)$this->request->post['port'];
						
			if($gameServer['server_status'] == 1){
				if($balance >= $portPrice){	
					if(!$this->serversFirewallsModel->getTotalFirewalls(array('server_id' => $serverid))){
						if(!$this->serversModel->getTotalServers(array('location_id' => $gameServer['location_id'], 'server_port' => $port))){
							$gameServerPorts = $this->serversModel->getGameServerPortList($gameServer['location_id'], $gameServer['game_min_port'], $gameServer['game_max_port']);	
							if (in_array($port, $gameServerPorts)) {
								$this->serversModel->updateServer($serverid, array('server_port' => $port));
								$this->usersModel->downUserBalance($userid, $portPrice);

								$wasteData = array(
									'user_id'		=> $userid,
									'waste_ammount'	=> $portPrice,
									'waste_status'	=> 1,
									'waste_usluga'	=> "Установлен порт $port для сервера gs$serverid"
								 ); 	
								$this->wasteModel->createWaste($wasteData);
								
								$user = $this->usersModel->getUserById($userid, array(), array(), array());
								
								if($user['ref'] != 0) {
									$ref_percent = $this->config->ref_percent;
									$getpref = ($portPrice * (1 + $ref_percent / 100)) - $portPrice;
									$this->usersModel->upUserBalance($user['ref'], $getpref);
									$this->usersModel->upUserRMoney($user['ref'], $getpref);
									
									$wasteData = array(
										'user_id'		=> $user['ref'],
										'waste_ammount'	=> $getpref,
										'waste_status'	=> 0,
										'waste_usluga'	=> "Бонус с реферала ID-$userid"
									); 
									$this->wasteModel->createWaste($wasteData);
								}
					
								$this->data['status'] = "success";
								$this->data['success'] = "Вы успешно сменили порт сервера на ".$port;
							} else {
								$this->data['status'] = 'error';
								$this->data['error'] = 'Выбранный порт не может быть использован!';
							}		
						} else {
							$this->data['status'] = "error";
							$this->data['error'] = "Выбранный порт уже занят другим сервером!";
						}
					} else {
						$this->data['status'] = "error";
						$this->data['error'] = "Необходимо удалить все заблокированные IP адреса!";
					}
				} else {
					$this->data['status'] = "error";
					$this->data['error'] = "На Вашем счету не хватает ".(round($portPrice-$balance, 2))." руб";
				}
			} else {
				$this->data['status'] = "error";
				$this->data['error'] = "Сервер должен быть выключен!";
			}
		}
		return json_encode($this->data);
	}
	
	public function changemap_go($serverid = null) {
		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'news/index');
		}
		if($this->user->getAccessLevel() < 0) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		
		$this->load->model('servers');
		
		$server = $this->serversModel->getServerById($serverid, array('games', 'locations'));
		
		$error = $this->validate($serverid);
		if($error) {
			$this->data['status'] = "error";
			$this->data['error'] = $error;
			return json_encode($this->data);
		}	
		
		if($server["server_status"] == 0) {
			$this->data["status"] = "error";
			$this->data["error"] = "Сервер заблокирован!";
			return json_encode($this->data);
		}

		if($server['server_status'] == 2){	
			$command = str_replace("'", "&#039;", "changelevel ".$_POST['map']."");
			$this->serversModel->action($serverid, 'sendcommand', array('command' => $command));
			
			$this->data['status'] = "success";
			$this->data['success'] = "Вы успешно сменили карту на ".$_POST['map']."!";
		}else{
			$this->data['status'] = "error";
			$this->data['error'] = "Сервер должен быть включен!";
		}
		return json_encode($this->data);
	}
	
	public function buy_months($serverid = null) {
		if(!$this->user->isLogged()) {  
	  		$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 1) {
	  		$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		
		$this->load->model('waste');
		$this->load->model('users');
		$this->load->model('servers');
		$this->load->model('serverLog');
		
		$error = $this->validate($serverid);
		if($error) {
			$this->data['status'] = "error";
			$this->data['error'] = $error;
			return json_encode($this->data);
		}	
		
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$months = @$this->request->post['months'];
			$userid = $this->user->getId();
			$balance = $this->user->getBalance();
			
			$server = $this->serversModel->getServerById($serverid, array('games'));
			
			$price = $server['server_slots'] * $server['game_price'];
			switch($months) {
				case "3":
					$months = 3;
					$price = $price * 0.95;
					break;
				case "6":
					$months = 6;
					$price = $price * 0.90;
					break;
				case "12":
					$months = 12;
					$price = $price * 0.85;
					break;
				default:
					$months = 1;
			}
			$price = $price * $months;
			if($balance >= $price) {
				if($server['server_status'] == 0) {
					$this->serversModel->updateServer($serverid, array('server_status' => 1));
					$this->serversModel->extendServer($serverid,$months,true);
					$this->serversModel->action($serverid, "updatepassm");
					$this->serversModel->action($serverid, "updatepass");
				} else {
					$this->serversModel->extendServer($serverid,$months,false);
				}
				$this->usersModel->downUserBalance($userid, $price);
				$wasteData = array(
					'user_id'		=> $userid,
					'waste_ammount'	=> $price,
					'waste_status'	=> 1,
					'waste_usluga'	=> "Продление сервера gs$serverid на $months месяц(а/ев)"
				);
				$this->wasteModel->createWaste($wasteData);
		
				$user = $this->usersModel->getUserById($userid, array(), array(), array());
						
				if($user['ref'] != 0) {
					$ref_percent = $this->config->ref_percent;
					$getpref = ($price * (1 + $ref_percent / 100)) - $price;
					$this->usersModel->upUserBalance($user['ref'], $getpref);
					$this->usersModel->upUserRMoney($user['ref'], $getpref);
										
					$wasteData = array(
						'user_id'		=> $user['ref'],
						'waste_ammount'	=> $getpref,
						'waste_status'	=> 0,
						'waste_usluga'	=> "Бонус с реферала ID-$userid"
					); 
					$this->wasteModel->createWaste($wasteData);
				}
				
				$logData = array(
					'server_id'			=> $serverid,
					'reason'            => 'Сервер успешно продлен!',
					'status'            => 1
				);
                $this->serverLogModel->createLog($logData);
				$this->data['status'] = "success";
				$this->data['success'] = "Вы успешно оплатили сервер на $months месяцев.";
		    } else {
				$logData = array(
					'server_id'			=> $serverid,
					'reason'            => '[PAY] На счету не достаточно средств!',
					'status'            => 3
				);
				$this->serverLogModel->createLog($logData);
				$this->data['status'] = "error";
				$this->data['error'] = "На Вашем счету не хватает ".(round($price-$balance, 2))." руб";	
			}
		}
		return json_encode($this->data);
	}
	
	private function validate($serverid) {
		$result = null;
		
		$userid = $this->user->getId();
		
		if(!$this->serversModel->getTotalServerOwners(array('server_id' => (int)$serverid, 'user_id' => (int)$userid, 'owner_status' => 1))) {
			if(!$this->serversModel->getTotalServers(array('server_id' => (int)$serverid, 'user_id' => (int)$userid))) {
				$result = "Запрашиваемый сервер не существует!";
			}
		}
		return $result;
	}
	
	private function validatePOST($serverid)
	{
		$this->load->library('validate');
		$this->load->model('games');
		$validateLib = new validateLibrary();
		$result = NULL;
		$server = $this->serversModel->getServerById($serverid, array('games', 'locations'));
		$gameid = $server['game_id'];
		$slots = $this->request->post['slots'];

		if (!$this->gamesModel->validateSlots($gameid, $slots)) {
			$result = 'Вы указали недопустимое количество слотов!';
		}
		elseif(!$validateLib->money($slots)) {
			$result = "Укажите количество слотов в допустимом формате!";
		}
		return $result;
	}
}
?>
