<?php
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)

Developed by Andrey Chikaev (https://vk.com/winchikplay)

*/
class fastdlController extends Controller {
	public function index($serverid = null) {
		$this->document->setActiveSection('servers');
		$this->document->setActiveItem('fastdl');
		
		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		
		if($this->user->getAccessLevel() < 0) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		
		$this->load->model('servers');
		
		$error = $this->validate($serverid);
		if($error) {
			$this->session->data['error'] = $error;
			$this->response->redirect($this->config->url . 'servers/index');
		}

		$this->data['server'] = $server = $this->serversModel->getServerById($serverid, array('games', 'locations'));
		
		include_once 'application/controllers/common/main.php';

		$this->getChild(array('common/header', 'common/footer'));
		return $this->load->view('servers/fastdl', $this->data);
	}

	public function action($action = null, $serverid = null) {
		if(!$this->user->isLogged()) {
			$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		
		if($this->user->getAccessLevel() < 1) {
			$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		
		$this->load->model('servers');

		$server = $this->serversModel->getServerById($serverid, array('games', 'locations'));
		
		$error = $this->validate($serverid);
		if($error) {
			$this->data['status'] = "error";
			$this->data['error'] = $error;
			return json_encode($this->data);
		}	
		
		if($server["server_status"] == 0) {
			$this->data["status"] = "error";
			$this->data["error"] = "Сервер заблокирован!";
			return json_encode($this->data);
		}
		
		if($server['game_code'] == "cs" || $server['game_code'] == "css" || $server['game_code'] == "csgo"){
			if($server['server_status'] == 1){
				switch($action) {
					case 'on': {
						if($server['fastdl_status'] == 0){			
							$this->load->library('ssh2');
							
							$ssh = new ssh2Library();
							
							$ip = $server['location_ip'];
							$user = $server['location_user'];
							$pass = $server['location_password'];
							
							
							$connect = $ssh->connect($ip, $user, $pass);

							$txt_end = "Options Indexes FollowSymLinks\n"; 
							$txt_end .= "AllowOverride None\n"; 
							$txt_end .= "Require all granted\n"; 
							$txt_end .= "<ifmodule mpm_itk_module>\n"; 
							$txt_end .= "AssignUserID gs" . $serverid . " gameservers\n"; 
							$txt_end .= "</IfModule>\n\n"; 
							$txt_end .= "</Directory>\n\n";
							
							$txt  = "Alias /gs" . $serverid . "/cstrike /home/gs" . $serverid . "/cstrike\n";
							$txt .= "<Directory /home/gs" . $serverid . "/cstrike>\n";
							$txt .= $txt_end;
							
							$ssh->execute($connect, 'echo "' . $txt . '" > /etc/apache2/sites-enabled/fastdl_gs' . $serverid . '.conf');
							$ssh->execute($connect, 'service apache2 restart');
							$ssh->disconnect($connect);
							$this->serversModel->updateServer($serverid, array('fastdl_status' => 1));
							$this->data['status'] = "success";
							$this->data['success'] = "FastDL подключается!";
						}elseif($server['fastdl_status'] == 1){
							$this->data['status'] = "error";
							$this->data['error'] = "FastDL Уже включён!";
						}
						break;
					}
					case 'off': {
						if($server['fastdl_status'] == 1){
							$this->load->library('ssh2');
							
							$ssh = new ssh2Library();
							
							$ip = $server['location_ip'];
							$user = $server['location_user'];
							$pass = $server['location_password'];
							
							
							$connect = $ssh->connect($ip, $user, $pass);
							$ssh->execute($connect, 'rm -rf /etc/apache2/sites-enabled/fastdl_gs' . $serverid . '.conf');
							$ssh->execute($connect, 'service apache2 restart');
							$ssh->disconnect($connect);
							$this->serversModel->updateServer($serverid, array('fastdl_status' => 0));
							$this->data['status'] = "success";
							$this->data['success'] = "FastDL успешно отключён!";
						}elseif($server['fastdl_status'] == 0){
							$this->data['status'] = "error";
							$this->data['error'] = "FastDL Уже отключён!";
						}
						break;
					}
					default: {
						$this->data['status'] = "error";
						$this->data['error'] = "Вы выбрали несуществующее действие!";
						break;
					}
				}
			} else {
				$this->data['status'] = "error";
				$this->data['error'] = "Сервер должен быть выключен!";
			}
		} else {
			$this->data['status'] = "error";
			$this->data['error'] = "Данная игра не поддержывает FastDL!";
		}
		return json_encode($this->data);
	}

	function validate($serverid) {
		$result = null;
		$userid = $this->user->getId();

		if(!$this->serversModel->getTotalServerOwners(array('server_id' => (int)$serverid, 'user_id' => (int)$userid, 'owner_status' => 1))) {
			if(!$this->serversModel->getTotalServers(array('server_id' => (int)$serverid, 'user_id' => (int)$userid))) {
				$result = "Запрашиваемый сервер не существует!";
			}
		}

		return $result;
	}
}