<?
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Alexandr Zemlyanoy (https://vk.com/mrsasha082)
WEB Hosting to ISP 5
*/
class controlController extends Controller {
	public function index($webid = null) {
		$this->document->setActiveSection('webhost');
		$this->document->setActiveItem('control');
		
		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		if($this->user->getAccessLevel() < 0) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		
		$this->load->model('webhost');		
        $this->load->model('webhostTarifs');
		$this->load->model('webLocations');
		
		$error = $this->validate($webid);
		if($error) {
			$this->session->data['error'] = $error;
			$this->response->redirect($this->config->url . 'webhost/index');
		}
		
		$webhost = $this->webhostModel->getWebhostById($webid, array('users','web_tarifs','web_locations'));
		$tarifs = $this->webhostTarifsModel->getTarifs(array('tarif_status' => 1));
		$locations = $this->webLocationsModel->getLocations(array('location_status' => 1));
		$this->data['webhost'] = $webhost;
		$this->data['tarifs'] = $tarifs;
		$this->data['locations'] = $locations;
		
		include_once 'application/controllers/common/main.php';

		$this->getChild(array('common/header', 'common/footer'));
		return $this->load->view('webhost/control', $this->data);
	}
	
	public function ajax($webid = null) {
		if(!$this->user->isLogged()) {  
	  		$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 1) {
	  		$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}	
		$this->load->model('webhost');
	
		$error = $this->validate($webid);
		if($error) {
			$this->data['status'] = "error";
			$this->data['error'] = $error;
			return json_encode($this->data);
		}
		
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$errorPOST = $this->validatePOST();
			if(!$errorPOST) {
				$editpassword = @$this->request->post['editpassword'];
				$password = @$this->request->post['password'];
				if($editpassword) {
					$this->webhostModel->updatepassUser($webid, $password);
					$this->webhostModel->updatepassFtp($webid, $password);	
					$this->webhostModel->updateWebhost($webid, array('web_password' => $password));	
					$this->data['status'] = "success";
					$this->data['success'] = "Пароль успешно изменен!";
				} else {
					$this->data['status'] = "error";
					$this->data['error'] = "Ошибка!";
				}
			} else {
				$this->data['status'] = "error";
				$this->data['error'] = $errorPOST;
			}
		}

		return json_encode($this->data);
	}
	
	public function buy_months($webid = null) {
		if(!$this->user->isLogged()) {  
	  		$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 1) {
	  		$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		
		$this->load->model('users');
		$this->load->model('webhost');
		$this->load->model('waste');
		$months = $this->request->post['months'];
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$userid = $this->user->getId();
			$balance = $this->user->getBalance();
			
			$webhost = $this->webhostModel->getWebhostById($webid, array('web_tarifs'));
			
			$price = $webhost['tarif_price'];
			switch($months) {
				case "3":
					$months = 3;
					$price = $price * 0.95;
					break;
				case "6":
					$months = 6;
					$price = $price * 0.90;
					break;
				case "12":
					$months = 12;
					$price = $price * 0.85;
					break;
				default:
					$months = 1;
			}
			$price = $price * $months;
			if($balance >= $price) {
				if($webhost['web_status'] == 0) {
					$this->webhostModel->extendWebhost($webid,$months,false);
					$this->webhostModel->unblockWebhost($webid);
				} else {
					$this->webhostModel->extendWebhost($webid,$months,false);
				}
				$wasteData = array(
					'user_id'		=> $userid,
					'waste_ammount'	=> $price,
					'waste_status'	=> 1,
					'waste_usluga'	=> "Продление веб-хостинга ws$webid на $months месяц(а/ев)"
				);
				$this->wasteModel->createWaste($wasteData);
				$this->usersModel->downUserBalance($userid, $price);
				
				$user = $this->usersModel->getUserById($userid, array(), array(), array());
				if($user['ref'] != 0) {			
					$ref_percent = $this->config->ref_percent;
					$getpref = ($price * (1 + $ref_percent / 100)) - $price;
					$this->usersModel->upUserBalance($user['ref'], $getpref);
					$this->usersModel->upUserRMoney($user['ref'], $getpref);
										
					$wasteData = array(
						'user_id'		=> $user['ref'],
						'waste_ammount'	=> $getpref,
						'waste_status'	=> 0,
						'waste_usluga'	=> "Бонус с реферала ID-$userid"
					); 
					$this->wasteModel->createWaste($wasteData);
				}
				
				$this->data['status'] = "success";
				$this->data['success'] = "Вы успешно оплатили веб-хостинг на $months месяцев!";
			} else {
				$this->data['status'] = "error";
				$this->data['error'] = "На Вашем счету недостаточно средств!";
			}
		}
		return json_encode($this->data);
	}

	private function validate($webid) {
		$result = null;
		
		$userid = $this->user->getId();
		
		if(!$this->webhostModel->getTotalWebhosts(array('web_id' => (int)$webid, 'user_id' => (int)$userid))) {
			$result = "Запрашиваемый веб-хостинг не существует!";
		}
		return $result;
	}

	private function validatePOST() {
		$this->load->library('validate');
		
		$validateLib = new validateLibrary();
		
		$result = null;
		
		$editpassword = @$this->request->post['editpassword'];
		$password = @$this->request->post['password'];
		$password2 = @$this->request->post['password2'];

		if($editpassword) {
			if(!$validateLib->password_web($password)) {
				$result = "Пароль должен содержать от 8 до 32 латинских букв, цифр и знаков <i>,.!?_-</i>!";
			}
			elseif(!$validateLib->password_web1($password)) {
				$result = "Вы придумали слабый пароль!";
			}
			elseif(!$validateLib->password_web2($password)) {
				$result = "Вы придумали простой пароль!";
			}
			elseif($password != $password2) {
				$result = "Введенные вами пароли не совпадают!";
			}
		}
		return $result;
	}
}
?>
