<?
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Alexandr Zemlyanoy (https://vk.com/mrsasha082)
WEB Hosting to ISP 5
*/
class ftpController extends Controller {
	public function index($webid = null) {
		$this->document->setActiveSection('webhost');
		$this->document->setActiveItem('ftp');

		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		if($this->user->getAccessLevel() < 0) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		
		$this->load->model('users');
		$this->load->model('webhost');		
        $this->load->model('webhostTarifs');
  		$error = $this->validate($webid);
		if($error) {
			$this->session->data['error'] = $error;
			$this->response->redirect($this->config->url . 'webhost/index');
		}
		
		$userid = $this->user->getId();
		
		$webhost = $this->webhostModel->getWebhostById($webid, array('users','web_tarifs', 'web_locations'));
		$this->data['webhost'] = $webhost;
		
		if(isset($_COOKIE["data-theme-ftp"])){
			$this->data['theme'] = $_COOKIE['data-theme-ftp'];
		} else{
			$this->data['theme'] = "/application/public/css/theme.css";
		}
		
		include_once 'application/controllers/common/main.php';
		
		$this->getChild(array('common/footer'));
		return $this->load->view('webhost/ftp', $this->data);
	}
	
	public function action_theme_ftp($action = null) {
		if(!$this->user->isLogged()) {
			$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 1) {
			$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		
		$this->data['userid'] = $userid = $this->user->getId();

		switch($action) {
			case 'default': {	
					$name = '/application/public/css/theme.css';
					setcookie('data-theme-ftp',$name,time() + (86400 * 5), '/' );
					$this->data['status'] = "success";
					$this->data['success'] = "Тема установлена!";
				break;
			}
			case 'windows': {	
					$name = '/application/public/css/elfinderT/windows-10/css/theme.css';
					setcookie('data-theme-ftp',$name,time() + (86400 * 5), '/' );
					$this->data['status'] = "success";
					$this->data['success'] = "Тема установлена!";
				break;
			}
			case 'material': {	
					$name = '/application/public/css/elfinderT/Material/css/theme.css';
					setcookie('data-theme-ftp',$name,time() + (86400 * 5), '/' );
					$this->data['status'] = "success";
					$this->data['success'] = "Тема установлена!";
				break;
			}
			case 'materialgray': {	
					$name = '/application/public/css/elfinderT/Material/css/theme-gray.css';
					setcookie('data-theme-ftp',$name,time() + (86400 * 5), '/' );
					$this->data['status'] = "success";
					$this->data['success'] = "Тема установлена!";
				break;
			}
			default: {
				$this->data['status'] = "error";
				$this->data['error'] = "Вы выбрали несуществующее действие!";
				break;
			}
		}

		return json_encode($this->data);
	}
	

	

	
	private function validate($webid) {
		$result = null;
		
		$userid = $this->user->getId();
		
		if(!$this->webhostModel->getTotalWebhosts(array('web_id' => (int)$webid, 'user_id' => (int)$userid))) {
			$result = "Запрашиваемый веб-хостинг не существует!";
		}
		return $result;
	}
	
	

	public function getftp($webid = null) {
  if(!$this->user->isLogged()) {
   $this->session->data['error'] = "Вы не авторизированы!";
   $this->response->redirect($this->config->url . 'account/login');
  }
  if($this->user->getAccessLevel() < 0) {
   $this->session->data['error'] = "У вас нет доступа к данному разделу!";
   $this->response->redirect($this->config->url);
  }
  
  $this->load->model('webhost');
  
  $error = $this->validate($webid);
  if($error) {   
    $this->session->data['error'] = $error;
    $this->response->redirect($this->config->url . 'webhost/index');
  }
  
  $webhost = $this->webhostModel->getWebhostById($webid, array('web_tarifs', 'web_locations'));  
  
  include_once 'engine_ftp/elFinderConnector.class.php';
  include_once 'engine_ftp/elFinder.class.php';
  include_once 'engine_ftp/elFinderVolumeDriver.class.php';
  include_once 'engine_ftp/elFinderVolumeLocalFileSystem.class.php';
  include_once 'engine_ftp/elFinderVolumeFTP.class.php';
 
function access($attr, $path, $data, $volume) {
	return strpos(basename($path), '.') === 0       // if file/folder begins with '.' (dot)
		? !($attr == 'read' || $attr == 'write')    // set read+write to false, other (locked+hidden) set to true
		:  null;                                    // else elFinder decide it itself
}
function logger($cmd, $result, $args, $elfinder) {
    $log = sprintf('[%s] %s:', date('r'), strtoupper($cmd));
    foreach ($result as $key => $value) {
        if (empty($value)) {
            continue;
        }
        $data = array();
        if (in_array($key, array('error', 'warning'))) {
            array_push($data, implode(' ', $value));
        } else {
            if (is_array($value)) { // changes made to files
                foreach ($value as $file) {
                    $filepath = (isset($file['realpath']) ? $file['realpath'] : $elfinder->realpath($file['hash']));
                    array_push($data, $filepath);
                }
            } else { // other value (ex. header)
                array_push($data, $value);
            }
        }
        $log .= sprintf(' %s(%s)', $key, implode(', ', $data));
    }
    $log .= "\n";

    $logfile = 'files/log.txt';
    $dir = dirname($logfile);
    if (!is_dir($dir) && !mkdir($dir)) {
        return;
    }
    if (($fp = fopen($logfile, 'a'))) {
        fwrite($fp, $log);
        fclose($fp);
    }
}
  $opts = array(
   'roots' => array(
    array(
     'driver' => 'FTP',
	 'URL' => 'ftp://ws'.$webhost['web_id'].':'.$webhost['web_password'].'@'.$webhost['location_ip'].':21/',
     'host'   => $webhost['location_ip'],
     'user'   => 'ws'.$webhost['web_id'],
     'pass'   => $webhost['web_password'],
     'port'   => 21,  
     'mode'   => 'passive',
     'path'   => '/',
	 'read' => true,
	 'write' => true,
	 'utf8fix' => true,
	  'bind' => array(
       'mkdir mkfile rename duplicate upload rm paste' => 'logger'
    ),
	'rootAlias'=>'Server Root',
              'fileURL'=>True,
              'dotFiles'=>True,
              'dirSize'=>True,
              'fileMode'=>0644,
              'dirMode'=>0775,
              'imgLib'=>False,
              'tmbDir'=>'.tmb',
              'tmbAtOnce'=>5,
              'debug'=>True
    ),

	'attributes' => array(
		 		array(
					'pattern' => '~/\.~',
		 			'read' => true,
		 			'write' => true,
		 			'hidden' => true
					
		 		),
		 		
		 	)
   )
  );

  $connector = new elFinderConnector(new elFinder($opts));
  $connector->run();
}

}
?>
