<?
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Alexandr Zemlyanoy (https://vk.com/mrsasha082)
WEB Hosting to ISP 5
*/
class orderController extends Controller {
	public function index() {
		$this->document->setActiveSection('webhost');
		$this->document->setActiveItem('order');
		
		if(!$this->user->isLogged()) {
			$this->session->data['error'] = "Вы не авторизированы!";
			$this->response->redirect($this->config->url . 'account/login');
		}
		if($this->user->getAccessLevel() < 0) {
			$this->session->data['error'] = "У вас нет доступа к данному разделу!";
			$this->response->redirect($this->config->url);
		}
		$this->load->model('webhostTarifs');
		$this->load->model('webLocations');
		$tarifs = $this->webhostTarifsModel->getTarifs(array('tarif_status' => 1));
		$locations = $this->webLocationsModel->getLocations(array('location_status' => 1));
		$this->data['tarifs'] = $tarifs;
		$this->data['locations'] = $locations;
		$this->getChild(array('common/header', 'common/footer'));
		return $this->load->view('webhost/order', $this->data);
	}
	
	public function promo() {
		if(!$this->user->isLogged()) {  
	  		$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 1) {
	  		$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		
		$this->load->model('users');
		
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$code = $this->request->post['code'];
			$skidka = $this->usersModel->getSkidkaByCode($code, false);$kofficent=(100-$skidka['skidka'])/100;
			if($skidka['skidka'] == NULL){
				$this->data['status'] = "error";
				$this->data['error'] = "Данного кода не существует";
			}else{
				$this->data['status'] = "success";
				$this->data['success'] = "Вы активировали скидку ".$skidka['skidka']."%";
				$this->data['skidka'] = $kofficent;
			}
		}

		return json_encode($this->data);
	}
	
	public function ajax() {
		if(!$this->user->isLogged()) {  
	  		$this->data['status'] = "error";
			$this->data['error'] = "Вы не авторизированы!";
			return json_encode($this->data);
		}
		if($this->user->getAccessLevel() < 1) {
	  		$this->data['status'] = "error";
			$this->data['error'] = "У вас нет доступа к данному разделу!";
			return json_encode($this->data);
		}
		
		$this->load->model('users');
		$this->load->model('waste');
		$this->load->model('webhost');
		$this->load->model('webhostTarifs');
		$this->load->model('webLocations');
		
		if($this->request->server['REQUEST_METHOD'] == 'POST') {
			$errorPOST = $this->validatePOST();
			if(!$errorPOST) {
				$tarifid = $this->request->post['tarifid'];
				$months = $this->request->post['months'];
				$locationid = $this->request->post['locationid'];
				$chars="qazxswedcvfrtgbnhyujmkiolp1234567890QAZXSWEDCVFRTGBNHYUJMKIOLP";
                $max=14; 
                $size=StrLen($chars)-1; 
			    $password=null;
				while($max--) 
                $password.=$chars[rand(0,$size)];
				$userid = $this->user->getId();
				$balance = $this->user->getBalance();
				$tarif = $this->webhostTarifsModel->getTarifById($tarifid);	
				$code = $this->request->post['promo'];
				$skidka = $this->usersModel->getSkidkaByCode($code,true);$kofficent=(100-$skidka['skidka'])/100;				
					$price = $tarif['tarif_price'];
				
					switch($months) {
						case "3":
							$months = 3;
							$price = $price * 0.95;
							break;
						case "6":
							$months = 6;
							$price = $price * 0.95;
							break;
						case "12":
							$months = 12;
							$price = $price * 0.95;
							break;
						default:
							$months = 1;
					}
				
					$price = $price * $months;
				
					if($skidka['skidka'] != NULL){
						$price = $price * $kofficent;
					}
				
					if($balance >= $price) {
						$webData = array(
							'user_id'			=> $userid,
							'location_id'		=> $locationid,
							'web_password'		=> $password,
							'tarif_id'		    => $tarifid,
							'web_status'		=> 1,
							'web_months'		=> $months
						);
						$package = $tarif['package'];
						$webid = $this->webhostModel->createWebhost($webData);
						$this->webhostModel->installWebhost($webid,$password,$package);
						$this->usersModel->downUserBalance($userid, $price);

						$wasteData = array(
						  'user_id'			=> $userid,
						  'waste_ammount'	=> $price,
						  'waste_status'	=> 1,
						  'waste_usluga'	=> "Заказ веб-хостинга ws$webid"
					    ); 
				        $this->wasteModel->createWaste($wasteData);
						
						$user = $this->usersModel->getUserById($userid, array(), array(), array());
						if($user['ref'] != 0) {				
							$ref_percent = $this->config->ref_percent;
							$getpref = ($price * (1 + $ref_percent / 100)) - $price;
							$this->usersModel->upUserBalance($user['ref'], $getpref);
							$this->usersModel->upUserRMoney($user['ref'], $getpref);
												
							$wasteData = array(
								'user_id'		=> $user['ref'],
								'waste_ammount'	=> $getpref,
								'waste_status'	=> 0,
								'waste_usluga'	=> "Бонус с реферала ID-$userid"
							); 
							$this->wasteModel->createWaste($wasteData);
						}
						
						$this->data['status'] = "success";
						$this->data['success'] = "Веб-хостинг №".$webid." успешно заказан.";
						$this->data['id'] = $webid;
					} else {
						$this->data['status'] = "error";
						$this->data['error'] = "На Вашем счету недостаточно средств!";
					}
			} else {
				$this->data['status'] = "error";
				$this->data['error'] = $errorPOST;
			}
		}

		return json_encode($this->data);
	}
	
	private function validatePOST() {
		$this->load->library('validate');
		
		$validateLib = new validateLibrary();
		
		$result = null;
		$tarifid = @$this->request->post['tarifid'];
		$months = @$this->request->post['months'];
		$locationid = @$this->request->post['locationid'];

		if(!$this->webhostTarifsModel->getTotalTarifs(array('tarif_id' => (int)$tarifid, 'tarif_status' => 1))) {
			$result = "Вы указали несуществующий тариф!";
		}
		elseif(!$this->webLocationsModel->getTotalLocations(array('location_id' => (int)$locationid, 'location_status' => 1))) {
			$result = "Вы указали несуществующую локацию!";
		}
		return $result;
	}
}
?>
