<?php
/*

Copyright (c) 2020 HACKCHIK (https://hackchik.ru)

Developed by Andrey Chikaev (https://vk.com/winchikplay)

*/
?>
<?php echo $admheader ?>
<?php
   $mysqlExists = false;
   if(function_exists("mysqli_connect"))
    $mysqlExists = true;
   
   $ssh2Exists = false;
   if(function_exists("ssh2_connect"))
    $ssh2Exists = true;
   
   $gdExists = false;
   if(function_exists("gd_info"))
    $gdExists = true;

   $modRewriteExists = false;
   if(in_array('mod_rewrite', apache_get_modules()))
    $modRewriteExists = true;
?>
<div class="kt-container  kt-container--fluid  kt-grid__item kt-grid__item--fluid" style="margin: 15px 0;">
   <div class="kt-portlet">
      <div class="kt-portlet__head">
         <div class="kt-portlet__head-label">
            <h3 class="kt-portlet__head-title">
               Проверка системы
            </h3>
         </div>
      </div>
      <div class="kt-portlet__body">
         <div class="table-scrollable table-scrollable-borderless">
            <table class="table table-hover table-light">
               <thead>
                  <tr>
                     <th>Функция</th>
                     <th>Статус</th>
                     <th>Установка</th>
                     <th>Информация</th>
                  </tr>
               </thead>
               <tbody>
                  <tr>
                     <td>Система</td>
                     <td>HOST by HackChik</td>
                     <td><i class="fa fa-check-circle"></i></td>
                     <td><?php echo php_uname() ?></td>
                  </tr>
                  <tr>
                     <td>php_mysql</td>
                     <td><?php if($mysqlExists): ?>Установлен<?php else: ?>Не установлен<?php endif; ?></td>
                     <td><?php if($mysqlExists): ?><i class="fa fa-check-circle"></i><?php else: ?><code>apt-get install php-mysql</code><?php endif; ?></td>
                     <td>Работоспособность бд для сервера.</td>
                  </tr>
                  <tr>
                     <td>php_ssh2</td>
                     <td><?php if($ssh2Exists): ?>Установлен<?php else: ?>Не установлен<?php endif; ?></td>
                     <td><?php if($ssh2Exists): ?><i class="fa fa-check-circle"></i><?php else: ?><code>apt-get install libssh2-php</code><?php endif; ?></td>
                     <td>Подключение по ssh.</td>
                  </tr>
                  <tr>
                     <td>php_gd</td>
                     <td><?php if($gdExists): ?>Установлен<?php else: ?>Не установлен<?php endif; ?></td>
                     <td><?php if($gdExists): ?><i class="fa fa-check-circle"></i><?php else: ?><code>apt-get install php-gd</code><?php endif; ?></td>
                     <td>Просмотр каптчи.</td>
                  </tr>
                  <tr>
                     <td>mod_rewrite</td>
                     <td><?php if($modRewriteExists): ?>Установлен<?php else: ?>Не установлен<?php endif; ?></td>
                     <td><?php if($modRewriteExists): ?><i class="fa fa-check-circle"></i><?php else: ?><code>a2enmod rewrite</code><?php endif; ?></td>
                     <td>Кэширование памяти.</td>
                  </tr>
               </tbody>
            </table>
         </div>
      </div>
   </div>
   <?php if($user_access_level == 3):?>
   <div class="kt-portlet">
      <div class="kt-portlet__head">
         <div class="kt-portlet__head-label">
            <h3 class="kt-portlet__head-title">
               Запуск cron
            </h3>
         </div>
      </div>
      <div class="kt-portlet__body">
         <div class="table-scrollable table-scrollable-borderless">
            <table class="table table-hover table-light">
               <thead>
                  <tr>
                     <th>Время</th>
                     <th>Ссылка для браузера</th>
                     <th>Crontab</th>
                  </tr>
               </thead>
               <tbody>
                  <tr>
                     <td>1 раз в 00:00</td>
                     <td><?php echo $url ?>main/cron/index?token=<?php echo $token ?></td>
                     <td><code>0 0 * * * curl http://127.0.0.1/main/cron/index?token=<?php echo $token ?></code></td>
                  </tr>
                  <tr>
                     <td>1 раз в минуту</td>
                     <td><?php echo $url ?>main/cron/gameServers?token=<?php echo $token ?></td>
                     <td><code>*/1 * * * * curl http://127.0.0.1/main/cron/gameServers?token=<?php echo $token ?></code></td>
                  </tr>
                  <tr>
                     <td>1 раз в 5 минут</td>
                     <td><?php echo $url ?>main/cron/updateSystemLoad?token=<?php echo $token ?></td>
                     <td><code>*/5 * * * * curl http://127.0.0.1/main/cron/updateSystemLoad?token=<?php echo $token ?></code></td>
                  </tr>
                  <tr>
                     <td>1 раз в 5 минут</td>
                     <td><?php echo $url ?>main/cron/gamelocationstatsupd?token=<?php echo $token ?></td>
                     <td><code>*/5 * * * * curl http://127.0.0.1/main/cron/gamelocationstatsupd?token=<?php echo $token ?></code></td>
                  </tr>
                  <tr>
                     <td>1 раз в 10 минут</td>
                     <td><?php echo $url ?>main/cron/serverReloader?token=<?php echo $token ?></td>
                     <td><code>0 */10 * * * curl http://127.0.0.1/main/cron/serverReloader?token=<?php echo $token ?></code></td>
                  </tr>
                  <tr>
                     <td>1 раз в 30 минут</td>
                     <td><?php echo $url ?>main/cron/updateStats?token=<?php echo $token ?></td>
                     <td><code>*/30 * * * * curl http://127.0.0.1/main/cron/updateStats?token=<?php echo $token ?></code></td>
                  </tr>
                  <tr>
                     <td>1 раз в 30 минут</td>
                     <td><?php echo $url ?>main/cron/updateStats?token=<?php echo $token ?></td>
                     <td><code>*/30 * * * * curl http://127.0.0.1/main/cron/stopServers?token=<?php echo $token ?></code></td>
                  </tr>
                  <tr>
                     <td>1 раз в 30 минут</td>
                     <td><?php echo $url ?>main/cron/stopServersQuery?token=<?php echo $token ?></td>
                     <td><code>*/30 * * * * curl http://127.0.0.1/main/cron/stopServersQuery?token=<?php echo $token ?></code></td>
                  </tr>
                  <tr>
                     <td>1 раз в неделю</td>
                     <td><?php echo $url ?>main/cron/clearLogs?token=<?php echo $token ?></td>
                     <td><code>0 * */7 * * curl http://127.0.0.1/main/cron/clearLogs?token=<?php echo $token ?></code></td>
                  </tr>
               </tbody>
            </table>
         </div>
      </div>
   </div>
   <?php endif; ?>
</div>
<?echo $footer?>