<?php
/*
Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Andrey Chikaev (https://vk.com/winchikplay)
*/
?>
<?php echo $admheader ?>
<div class="kt-container  kt-container--fluid  kt-grid__item kt-grid__item--fluid" style="margin: 15px 0;">
   <div class="kt-portlet">
      <div class="kt-portlet__head">
         <div class="kt-portlet__head-label">
            <h3 class="kt-portlet__head-title">
               Список пользователей
            </h3>
         </div>
		 <?php if($user_access_level == 3):?>
         <div class="kt-portlet__head-toolbar">
            <a data-toggle="modal" data-target="#modal-bonus" class="btn btn-label-brand btn-sm btn-icon btn-icon-md" data-toggle="kt-tooltip" data-placement="right" title="" data-original-title="Провести акцию">
            <i class="flaticon2-gift-1"></i>
            </a>
         </div>
		 <?php endif; ?>
      </div>
      <div class="kt-portlet__body">
         <div class="kt-section">
            <div class="kt-section__content">
               <table class="table table-striped m-table">
                  <thead>
                     <tr>
                        <th><i class="fa fa-list-ol"></i></th>
                        <th>Статус</th>
                        <th>Пользователь</th>
                        <th>E-mail</th>
                        <th>Дата регистрации</th>
                        <th>Статус активации</th>
                     </tr>
                  </thead>
                  <tbody>
                     <?php foreach($users as $item): ?> 
                     <tr onClick="redirect('/admin/users/edit/index/<?php echo $item['user_id'] ?>')">
                        <th scope="row"><?php echo $item['user_id'] ?></th>
                        <td>
                           <?php if($item['user_status'] == 0): ?>
                           <span class="badge badge-warning">Заблокирован</span>
                           <?php elseif($item['user_status'] == 1): ?>
                           <span class="badge badge-success">Активен</span>
                           <?php endif; ?>
                        </td>
                        <td><?php echo $item['user_firstname'] ?> <?php echo $item['user_lastname'] ?></td>
                        <td><?php echo $item['user_email'] ?></td>
                        <td><?php echo date("d.m.Y", strtotime($item['user_date_reg'])) ?></td>
                        <td>
                           <?php if($item['user_activate'] == 0): ?>
                           <span class="badge badge-danger">Не подтвержден</span>
                           <?php elseif($item['user_activate'] == 1): ?>
                           <span class="badge badge-info">Подтвержден</span>
                           <?php endif; ?>
                        </td>
                     </tr>
                     <?php endforeach; ?>
                     <?php if(empty($users)): ?> 
                     <tr>
                        <td colspan="6" style="text-align: center;">На данный момент нет пользователей.</td>
                     </tr>
                     <?php endif; ?> 
                  </tbody>
               </table>
               <?php echo $pagination ?> 
            </div>
         </div>
      </div>
   </div>
</div>
<!--begin::Modal-->
<div class="modal fade" id="modal-bonus" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
   <div class="modal-dialog" role="document">
      <div class="modal-content">
         <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Проведение акции</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
            </button>
         </div>
         <div class="modal-body">
            <form class="form-group form-md-line-input" action="#" id="sendFormBonus" method="POST">
               <div class="form-group form-md-line-input">
                  <input type="text" class="form-control" id="minsum" name="minsum" placeholder="Введите минимальный бонус">
               </div>
               <div class="form-group form-md-line-input">
                  <input type="text" class="form-control" id="maxsum" name="maxsum" placeholder="Введите максимальный бонус">
               </div>
               <hr>
               <div class="m-form__group form-group">
                  <label class="m-checkbox m-checkbox--bold m-checkbox--state-brand">
                  <input type="checkbox" id="typesum" name="typesum"> Раздача реальных денег
                  <span></span>
                  </label>
                  <br>
                  <label class="m-checkbox m-checkbox--bold m-checkbox--state-brand">
                  <input type="checkbox" id="oneuser" name="oneuser" onChange="toggleOneuser()"> Выдать только 1 пользователю
                  <span></span>
                  </label>
                  <br>
                  <label class="m-checkbox m-checkbox--bold m-checkbox--state-brand">
                  <input type="checkbox" id="createnews" name="createnews"> Создавать новость об проведённом розыгрыше
                  <span></span>
                  </label>
               </div>
               <hr>
               <div class="form-group form-md-line-input">
                  <input type="text" class="form-control" id="oneuserID" name="oneuserID" placeholder="Введите ID пользователя" disabled>
               </div>
         </div>
         <div class="modal-footer">
         <button type="button" class="btn btn-secondary" data-dismiss="modal">Отмена</button>
         <input class="btn m-btn--square  btn-info" type="submit" value="Начать акцию">
         </div>
         </form>
      </div>
   </div>
</div>
<!--end::Modal-->
<script>
   $('#sendFormBonus').ajaxForm({ 
       url: '/admin/users/index/ajax/',
       dataType: 'text',
       success: function(data) {
           console.log(data);
           data = $.parseJSON(data);
           switch(data.status) {
               case 'error':
                   toastr.error(data.error);
                   $('button[type=submit]').prop('disabled', false);
                   document.getElementById("oneuserID").value = "";
                   break;
               case 'success':
                   toastr.success(data.success);
                   document.getElementById("oneuserID").value = "";
                   break;
               case 'info':
                   toastr.info(data.info);
                   document.getElementById("oneuserID").value = "";
                   break;
           }   
       },
       beforeSubmit: function(arr, $form, options) {
       }
   });
   function toggleOneuser() {
       var status = $('#oneuser').is(':checked');
       if(status) {
           $('#oneuserID').prop('disabled', false);
       } else {
           $('#oneuserID').prop('disabled', true);
       }
   }
</script>				
<?php echo $footer ?>
