<?php
/*
Copyright (c) 2020 HACKCHIK (https://hackchik.ru)
Developed by Andrey Chikaev (https://vk.com/winchikplay)
*/
?>
<?php echo $header ?>
<div class="kt-container  kt-container--fluid  kt-grid__item kt-grid__item--fluid" style="margin: 15px 0;">
   <div class="row">
      <div class="col-lg-4 col-xl-4 order-lg-2 order-xl-1">
         <div class="kt-portlet">
            <div class="kt-portlet__body">
               <div class="kt-widget kt-widget--general-1">
                  <div class="kt-media kt-media--brand kt-media--md kt-media--circle">
                     <img src="<?php echo $url ?><?php echo $user_img ?>" alt="image">
                  </div>
                  <div class="kt-widget__wrapper">
                     <div class="kt-widget__label">
                        <a href="#" class="kt-widget__title">
                        <?php echo $user_lastname ?> <?php echo $user_firstname ?>
                        </a>
                        <span class="kt-widget__desc">
                        <?if($user_access_level == 1):?>
                        Пользователь
                        <?endif; ?>
                        <?if($user_access_level == 2):?>
                        Тех.поддержка
                        <?endif; ?>
                        <?if($user_access_level == 3):?>
                        Администратор
                        <?endif; ?>
                        </span>
                     </div>
                  </div>
                  <div class="kt-widget__toolbar kt-widget__toolbar--top-">
                     <div class="btn-group">
                        <div class="dropdown dropdown-inline">
                           <button type="button" class="btn btn-clean btn-sm btn-icon btn-icon-md" data-toggle="kt-tooltip" data-placement="right" title="" data-original-title="Техническая поддержка пользователей">
                           <i class="flaticon2-information"></i>
                           </button>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
            <div class="kt-portlet__separator"></div>
            <div class="kt-portlet__body">
               <ul class="kt-nav kt-nav--bolder kt-nav--fit-ver kt-nav--v4" role="tablist">
                  <li class="kt-nav__item">
                     <a class="kt-nav__link " href="/tickets" role="tab">
                     <span class="kt-nav__link-icon"><i class="fa fa-address-book"></i></span>
                     <span class="kt-nav__link-text">Мои запросы</span>
                     </a>
                  </li>
                  <li class="kt-nav__item  active">
                     <a class="kt-nav__link" href="/tickets/create" role="tab">
                     <span class="kt-nav__link-icon"><i class="fa fa-headset"></i></span>
                     <span class="kt-nav__link-text">Создать запрос</span>
                     </a>
                  </li>
                  <li class="kt-nav__item  ">
                     <a class="kt-nav__link" href="/faq" role="tab">
                     <span class="kt-nav__link-icon"><i class="fa fa-book"></i></span>
                     <span class="kt-nav__link-text">База знаний</span>
                     </a>
                  </li>
               </ul>
            </div>
         </div>
      </div>
      <div class="col-lg-8 col-xl-8 order-lg-2 order-xl-1">
         <div class="m-portlet m-portlet--full-height m-portlet--tabs   m-portlet--unair">
            <div class="m-portlet__body">
               <form action="#" method="POST" id="createForm" class="form-group form-md-line-input">
                  <div class="form-group form-md-line-input">
                     <input type="text" class="form-control" id="name" name="name" placeholder="Введите тему">
                  </div>
                  <div class="form-group form-md-line-input">
                     <select class="form-control" id="category" name="category" aria-required="true" aria-invalid="false" aria-describedby="delivery-error">
                        <?php foreach($category as $item): ?> 
                        <option value="<?php echo $item['category_id'] ?>"><?php echo $item['category_name'] ?></option>
                        <?php endforeach; ?> 
                        <?php foreach($servers as $item2): ?> 
                        <option value="NULL">Сервер (<?php echo $item2['location_ip'] ?>:<?php echo $item2['server_port'] ?>)</option>
                        <?php endforeach; ?> 
                     </select>
                  </div>
                  <div class="form-group form-md-line-input">
                     <textarea class="form-control" id="text" name="text" rows="3" placeholder="Сообщение..."></textarea>
                  </div>
                  <div class="form-group form-md-line-input">
                    <label class="col-sm-3 control-label">Импорт изображения:</label>
                    <input class="form-control" type="file" name="file[]" multiple id="file">
                  </div>
                  <div class="recaptcha">
                     <center>
                        <div class="g-recaptcha" data-sitekey="<?php echo $recaptcha ?>" id="recaptcha1"></div>
                     </center>
                  </div>
                  <hr>
                  <button type="submit" class="btn btn-info m-btn m-btn--air btn-outline  btn-block sbold uppercase">Отправить</button>
               </form>
            </div>
         </div>
      </div>
   </div>
</div>
<script src="https://www.google.com/recaptcha/api.js?onload=recaptha&render=explicit" async defer></script>
<script>
	var captcha_ticket;	
    var recaptha = function() {	
		captcha_ticket = grecaptcha.render('recaptcha1', {
			'sitekey' : '<?php echo $recaptcha ?>',
		    'theme' : 'light'
		});			
	};	
	
   $('#createForm').ajaxForm({ 
    url: '/tickets/create/ajax',
    dataType: 'text',
    success: function(data) {
        console.log(data);
        data = $.parseJSON(data);
        switch(data.status) {
            case 'error':
                toastr.error(data.error);
				grecaptcha.reset(captcha_ticket);
                $('button[type=submit]').prop('disabled', false);
                break;
            case 'success':
                toastr.success(data.success);
                setTimeout("redirect('/tickets/view/index/" + data.id + "')", 1500);
                break;
        }
    },
    beforeSubmit: function(arr, $form, options) {
        $('button[type=submit]').prop('disabled', true);
    }
   });
</script>
<?php echo $footer ?>